import * as i0 from '@angular/core';
import { Injectable, input, inject, Component, ViewChild } from '@angular/core';
import * as i1 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import { Subject, takeUntil } from 'rxjs';
import * as i1$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i3 from 'ngx-mask';

var FormFieldTxtInputTypesEnum;
(function (FormFieldTxtInputTypesEnum) {
    FormFieldTxtInputTypesEnum[FormFieldTxtInputTypesEnum["Text"] = 0] = "Text";
    FormFieldTxtInputTypesEnum[FormFieldTxtInputTypesEnum["Password"] = 1] = "Password";
    FormFieldTxtInputTypesEnum[FormFieldTxtInputTypesEnum["Email"] = 2] = "Email";
    FormFieldTxtInputTypesEnum[FormFieldTxtInputTypesEnum["Number"] = 3] = "Number";
    FormFieldTxtInputTypesEnum[FormFieldTxtInputTypesEnum["Date"] = 4] = "Date";
    FormFieldTxtInputTypesEnum[FormFieldTxtInputTypesEnum["DateTime"] = 5] = "DateTime";
    FormFieldTxtInputTypesEnum[FormFieldTxtInputTypesEnum["CellPhone"] = 6] = "CellPhone";
})(FormFieldTxtInputTypesEnum || (FormFieldTxtInputTypesEnum = {}));
var FormFieldTypes;
(function (FormFieldTypes) {
    FormFieldTypes[FormFieldTypes["TxtBox"] = 0] = "TxtBox";
    FormFieldTypes[FormFieldTypes["ComboBox"] = 1] = "ComboBox";
})(FormFieldTypes || (FormFieldTypes = {}));
var FormFieldCountryDataFormat;
(function (FormFieldCountryDataFormat) {
    FormFieldCountryDataFormat[FormFieldCountryDataFormat["Estados_Unidos"] = 0] = "Estados_Unidos";
    FormFieldCountryDataFormat[FormFieldCountryDataFormat["Brasil"] = 1] = "Brasil";
})(FormFieldCountryDataFormat || (FormFieldCountryDataFormat = {}));
var FormFieldIconsEnum;
(function (FormFieldIconsEnum) {
    FormFieldIconsEnum["AddUser"] = "fi fi-sr-user-add";
    FormFieldIconsEnum["User"] = "fi fi-sr-user";
    FormFieldIconsEnum["Lock"] = "fi fi-sr-lock";
    FormFieldIconsEnum["EyeOpen"] = "fi fi-ss-eye";
    FormFieldIconsEnum["EyeClose"] = "fi fi-ss-eye-crossed";
    FormFieldIconsEnum["ItemClosed"] = "fi fi-tr-caret-down";
    FormFieldIconsEnum["ItemOpenned"] = "fi fi-rr-caret-down";
    FormFieldIconsEnum["Done_Fill"] = "fi fi-sr-octagon-check";
    FormFieldIconsEnum["Done_OutLine"] = "fi fi-rr-check-circle";
    FormFieldIconsEnum["Doing_Pending_Outline"] = "fi fi-br-duration-alt";
    FormFieldIconsEnum["Doing_Pending_Fill"] = "fi fi-ss-duration-alt";
    FormFieldIconsEnum["NotDone"] = "fi fi-sr-cross-circle";
    FormFieldIconsEnum["Alert"] = "fi fi-sr-exclamation";
    FormFieldIconsEnum["Close"] = "fi fi-br-cross";
    FormFieldIconsEnum["Home"] = "fi fi-sr-home";
    FormFieldIconsEnum["Key"] = "fi fi-sr-key";
    FormFieldIconsEnum["Company"] = "fi fi-rs-building";
    FormFieldIconsEnum["NoteBook"] = "fi fi-br-notebook-alt";
    FormFieldIconsEnum["AddFile"] = "fi fi-rr-add-document";
    FormFieldIconsEnum["PageGoBack"] = "fi fi-rr-angle-circle-left";
    FormFieldIconsEnum["PDFFile"] = "fi fi-sr-file-pdf";
    FormFieldIconsEnum["DowloadFile"] = "fi fi-sr-file-download";
    FormFieldIconsEnum["Phone"] = "fi fi-sr-phone-call";
    FormFieldIconsEnum["Edit"] = "fi fi-sr-pencil";
    FormFieldIconsEnum["Delete"] = "fi fi-sr-trash";
    FormFieldIconsEnum["Rotas"] = "fi fi-br-route";
    FormFieldIconsEnum["Hamburger"] = "fi fi-br-menu-burger";
    FormFieldIconsEnum["Lubrificacao"] = "fi fi-rr-oil-can";
})(FormFieldIconsEnum || (FormFieldIconsEnum = {}));
var FormFieldFontWeights;
(function (FormFieldFontWeights) {
    FormFieldFontWeights[FormFieldFontWeights["Thin"] = 100] = "Thin";
    FormFieldFontWeights[FormFieldFontWeights["ExtraLight"] = 200] = "ExtraLight";
    FormFieldFontWeights[FormFieldFontWeights["Light"] = 300] = "Light";
    FormFieldFontWeights[FormFieldFontWeights["Regular"] = 400] = "Regular";
    FormFieldFontWeights[FormFieldFontWeights["Medium"] = 500] = "Medium";
    FormFieldFontWeights[FormFieldFontWeights["SemiBold"] = 600] = "SemiBold";
    FormFieldFontWeights[FormFieldFontWeights["Bold"] = 700] = "Bold";
    FormFieldFontWeights[FormFieldFontWeights["Extrabold"] = 800] = "Extrabold";
    FormFieldFontWeights[FormFieldFontWeights["Black"] = 900] = "Black";
})(FormFieldFontWeights || (FormFieldFontWeights = {}));

class FormFieldService {
    constructor() {
        this.valueChanged = new Subject();
        this.alertState = new Subject();
        this.enterPressed = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: FormFieldService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: FormFieldService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: FormFieldService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class FormFieldModel {
    constructor() {
        this.name = '';
        this.field = {};
        this.internalCall = false;
    }
}
class FormFielTxtModel {
    constructor() {
        this.value = '';
    }
}
class FormFieldComboModel {
    constructor() {
        this.id = 0;
        this.value = '';
    }
}

var AlertIconsEnum;
(function (AlertIconsEnum) {
    AlertIconsEnum["AddUser"] = "fi fi-sr-user-add";
    AlertIconsEnum["User"] = "fi fi-sr-user";
    AlertIconsEnum["Lock"] = "fi fi-sr-lock";
    AlertIconsEnum["EyeOpen"] = "fi fi-ss-eye";
    AlertIconsEnum["EyeClose"] = "fi fi-ss-eye-crossed";
    AlertIconsEnum["ItemClosed"] = "fi fi-tr-caret-down";
    AlertIconsEnum["ItemOpenned"] = "fi fi-rr-caret-down";
    AlertIconsEnum["Done_Fill"] = "fi fi-sr-octagon-check";
    AlertIconsEnum["Done_OutLine"] = "fi fi-rr-check-circle";
    AlertIconsEnum["Doing_Pending_Outline"] = "fi fi-br-duration-alt";
    AlertIconsEnum["Doing_Pending_Fill"] = "fi fi-ss-duration-alt";
    AlertIconsEnum["NotDone"] = "fi fi-sr-cross-circle";
    AlertIconsEnum["Alert"] = "fi fi-sr-exclamation";
    AlertIconsEnum["Close"] = "fi fi-br-cross";
    AlertIconsEnum["Home"] = "fi fi-sr-home";
    AlertIconsEnum["Key"] = "fi fi-sr-key";
    AlertIconsEnum["Company"] = "fi fi-rs-building";
    AlertIconsEnum["NoteBook"] = "fi fi-br-notebook-alt";
    AlertIconsEnum["AddFile"] = "fi fi-rr-add-document";
    AlertIconsEnum["PageGoBack"] = "fi fi-rr-angle-circle-left";
    AlertIconsEnum["PDFFile"] = "fi fi-sr-file-pdf";
    AlertIconsEnum["DowloadFile"] = "fi fi-sr-file-download";
    AlertIconsEnum["Phone"] = "fi fi-sr-phone-call";
    AlertIconsEnum["Edit"] = "fi fi-sr-pencil";
    AlertIconsEnum["Delete"] = "fi fi-sr-trash";
    AlertIconsEnum["Rotas"] = "fi fi-br-route";
    AlertIconsEnum["Hamburger"] = "fi fi-br-menu-burger";
    AlertIconsEnum["Lubrificacao"] = "fi fi-rr-oil-can";
})(AlertIconsEnum || (AlertIconsEnum = {}));
var AlertTypesEnum;
(function (AlertTypesEnum) {
    AlertTypesEnum[AlertTypesEnum["Done"] = 0] = "Done";
    AlertTypesEnum[AlertTypesEnum["Alert"] = 1] = "Alert";
    AlertTypesEnum[AlertTypesEnum["NotDone"] = 2] = "NotDone";
})(AlertTypesEnum || (AlertTypesEnum = {}));

class AlertService {
    constructor() {
        this.wasOpenned = new Subject();
        this.wasClosed = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: AlertService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: AlertService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: AlertService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class AlertModel {
    constructor() {
        this.alertsName_DontSet = '';
        this.alertsFatherName = '';
        this.top_DontSet = 0;
        this.left_DontSet = 0;
        this.text = '';
        this.isFixPosition = false;
        this.wasClosed_DontSet = false;
    }
}

class AlertComponent {
    constructor(cd) {
        this.cd = cd;
        this.Name = input.required();
        this._FontSize = input.required();
        this._FontFamily = input.required();
        this._FontWeight = input.required();
        this._FontColor = 'white';
        this._Text = '';
        this._PositionY = 0;
        this._PositionX = 0;
        this._Icon = '';
        this.BackgroundColor = '';
        this._IconClose = '';
        this.isVisible = false;
        this.AlertService = inject(AlertService);
    }
    ngOnInit() {
        this._PositionX = 0;
        this._PositionY = 0;
        this._FontColor = 'white';
        this._Icon = '';
        this.BackgroundColor = '';
        this._IconClose = '';
        this.AlertModel = new AlertModel();
        this._IconClose = AlertIconsEnum.Close;
        this.startListenToAlertShowed();
    }
    OnClose() {
        this.isVisible = false;
        this.AlertModel.alertsName_DontSet = this.Name();
        this.AlertModel.wasClosed_DontSet = true;
        this.AlertService.wasClosed.next(this.AlertModel);
    }
    startListenToAlertShowed() {
        this.AlertService.wasOpenned.subscribe((AlertModel) => {
            if (this.Name() == AlertModel.alertsName_DontSet) {
                this._Text = AlertModel.text;
                this.AlertType = AlertModel.type;
                this.isFixPosition = AlertModel.isFixPosition;
                this.isVisible = true;
                switch (this.AlertType) {
                    case (AlertTypesEnum.Done):
                        this._Icon = AlertIconsEnum.Done_Fill;
                        this.BackgroundColor = '#008B10';
                        this._FontColor = 'white';
                        break;
                    case (AlertTypesEnum.Alert):
                        this._Icon = AlertIconsEnum.Alert;
                        this.BackgroundColor = '#DFCD00';
                        this._FontColor = 'black';
                        break;
                    case (AlertTypesEnum.NotDone):
                        this._Icon = AlertIconsEnum.NotDone;
                        this.BackgroundColor = '#D40000';
                        this._FontColor = 'white';
                        break;
                }
                if (this.isFixPosition) {
                }
                else {
                    this._PositionY = AlertModel.top_DontSet;
                    this._PositionX = AlertModel.left_DontSet;
                }
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: AlertComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.2.0", type: AlertComponent, isStandalone: true, selector: "app-alert", inputs: { Name: { classPropertyName: "Name", publicName: "Name", isSignal: true, isRequired: true, transformFunction: null }, _FontSize: { classPropertyName: "_FontSize", publicName: "_FontSize", isSignal: true, isRequired: true, transformFunction: null }, _FontFamily: { classPropertyName: "_FontFamily", publicName: "_FontFamily", isSignal: true, isRequired: true, transformFunction: null }, _FontWeight: { classPropertyName: "_FontWeight", publicName: "_FontWeight", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0, template: "\r\n<div class=\"container\"\r\n[style.display]=\"isFixPosition ? 'flex' : ''\"\r\n[style.position]=\"isFixPosition ? 'fixed' : 'absolute'\"\r\n[style.width]=\"isFixPosition ? '100%' : ''\"\r\n[style.padding-top]=\" isFixPosition ? _FontSize()+'px' : '0'\"\r\n[style.top]=\"isFixPosition?'0px':_PositionY+'px'\"\r\n[style.left]=\"isFixPosition?'0px':_PositionX+'px'\"\r\n>\r\n    <div class=\"body\"\r\n    [style.background-color]=\"BackgroundColor\"\r\n    [style.border-radius]=\"(_FontSize()*0.5) + 'px'\"\r\n    [style.color]=\"_FontColor\"\r\n    [style.display]=\"isVisible ? '' : 'none'\"\r\n\r\n    >\r\n    \r\n        <i class=\"{{_IconClose}}\"\r\n        [style.font-size]=\"(_FontSize()*1) + 'px'\"\r\n        [style.padding-top]=\"(_FontSize()*0.6) + 'px'\"\r\n        [style.padding-right]=\"(_FontSize()*0.6) + 'px'\"\r\n        (click)=\"OnClose()\"\r\n        >\r\n    \r\n        </i>\r\n    \r\n        <div class=\"container-text\"\r\n        [style.margin-right]=\"_FontSize() + 'px'\"\r\n        [style.padding-top]=\"(_FontSize()*0.4) + 'px'\"\r\n        [style.padding-bottom]=\"(_FontSize()*1) + 'px'\"\r\n        [style.padding-right]=\"(_FontSize()*1) + 'px'\"\r\n        [style.padding-left]=\"(_FontSize()*1) + 'px'\"\r\n        >\r\n            <i class=\"{{_Icon}}\"\r\n            [style.font-size]=\"(_FontSize()*1.2) + 'px'\"\r\n            [style.margin-right]=\"(_FontSize()*0.5) + 'px'\"\r\n            >\r\n            </i>\r\n\r\n            <p\r\n            [style.font-family]=\"_FontFamily()\"\r\n            [style.font-weight]=\"_FontWeight()\"\r\n            [style.font-size]=\"_FontSize() + 'px'\"\r\n            >\r\n                {{_Text}}\r\n            </p>\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n", styles: [".container{align-items:center;justify-content:center;height:auto}.container>.body{width:fit-content;height:auto;max-width:70vw}.container>.body>i{display:block;line-height:0px;text-align:end}.container>.body>i:hover{cursor:pointer}.container>.body>.container-text{display:flex;align-items:center;justify-content:center;height:auto}.container>.body>.container-text>i{line-height:0px;text-align:center}.container>.body>.container-text>p{margin:0;text-align:justify;line-height:normal}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: AlertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-alert', standalone: true, imports: [], template: "\r\n<div class=\"container\"\r\n[style.display]=\"isFixPosition ? 'flex' : ''\"\r\n[style.position]=\"isFixPosition ? 'fixed' : 'absolute'\"\r\n[style.width]=\"isFixPosition ? '100%' : ''\"\r\n[style.padding-top]=\" isFixPosition ? _FontSize()+'px' : '0'\"\r\n[style.top]=\"isFixPosition?'0px':_PositionY+'px'\"\r\n[style.left]=\"isFixPosition?'0px':_PositionX+'px'\"\r\n>\r\n    <div class=\"body\"\r\n    [style.background-color]=\"BackgroundColor\"\r\n    [style.border-radius]=\"(_FontSize()*0.5) + 'px'\"\r\n    [style.color]=\"_FontColor\"\r\n    [style.display]=\"isVisible ? '' : 'none'\"\r\n\r\n    >\r\n    \r\n        <i class=\"{{_IconClose}}\"\r\n        [style.font-size]=\"(_FontSize()*1) + 'px'\"\r\n        [style.padding-top]=\"(_FontSize()*0.6) + 'px'\"\r\n        [style.padding-right]=\"(_FontSize()*0.6) + 'px'\"\r\n        (click)=\"OnClose()\"\r\n        >\r\n    \r\n        </i>\r\n    \r\n        <div class=\"container-text\"\r\n        [style.margin-right]=\"_FontSize() + 'px'\"\r\n        [style.padding-top]=\"(_FontSize()*0.4) + 'px'\"\r\n        [style.padding-bottom]=\"(_FontSize()*1) + 'px'\"\r\n        [style.padding-right]=\"(_FontSize()*1) + 'px'\"\r\n        [style.padding-left]=\"(_FontSize()*1) + 'px'\"\r\n        >\r\n            <i class=\"{{_Icon}}\"\r\n            [style.font-size]=\"(_FontSize()*1.2) + 'px'\"\r\n            [style.margin-right]=\"(_FontSize()*0.5) + 'px'\"\r\n            >\r\n            </i>\r\n\r\n            <p\r\n            [style.font-family]=\"_FontFamily()\"\r\n            [style.font-weight]=\"_FontWeight()\"\r\n            [style.font-size]=\"_FontSize() + 'px'\"\r\n            >\r\n                {{_Text}}\r\n            </p>\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n", styles: [".container{align-items:center;justify-content:center;height:auto}.container>.body{width:fit-content;height:auto;max-width:70vw}.container>.body>i{display:block;line-height:0px;text-align:end}.container>.body>i:hover{cursor:pointer}.container>.body>.container-text{display:flex;align-items:center;justify-content:center;height:auto}.container>.body>.container-text>i{line-height:0px;text-align:center}.container>.body>.container-text>p{margin:0;text-align:justify;line-height:normal}\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }] });

class FormFieldComponent {
    constructor(element, cd) {
        this.element = element;
        this.cd = cd;
        //Template Properties
        this._Icon = input.required();
        this.Name = input.required();
        this._placeHolderType = '';
        this._placeHolderValue = input.required();
        this._PasswordIcon = FormFieldIconsEnum.EyeOpen;
        this._IconColor = input.required();
        this._FontColor = input.required();
        this._FontSize = input.required();
        this._FontFamily = input.required();
        this._FontWeight = input.required();
        this._Options = input.required();
        this._Width = input.required();
        this._Height = input.required();
        //Internal Properties
        this.TxtInputType = input.required();
        this.IconEnabled = input.required();
        this.CountryDataFormat = input.required();
        this.text = '';
        this._AlertState = false;
        this.FieldType = input.required();
        //ngxMask
        this.Mask = "";
        this.Prefixo = "";
        this.Sufixo = "";
        this.NumberMaskSufix = input.required();
        this.showMaskTyped = false;
        this.thousandSeparator = ".";
        this.NCasasDecimais = input.required();
        this.FormFieldModel = new FormFieldModel();
        this.FormFielTxtModel = new FormFielTxtModel();
        this.FormFieldComboModel = new FormFieldComboModel();
        this.AlertTypesEnum = AlertTypesEnum;
        this.FormFieldIconsEnum = FormFieldIconsEnum;
        this.FormFieldTxtInputTypesEnum = FormFieldTxtInputTypesEnum;
        this.FormFieldDataFormat = FormFieldCountryDataFormat;
        this.FormFieldTypes = FormFieldTypes;
        //Services
        this.FormFieldService = inject(FormFieldService);
        this.AlertService = inject(AlertService);
    }
    ngOnInit() {
        //Limpa as Memórias de Estado
        this._placeHolderType = '';
        this._AlertState = false;
        this.FormFieldModel.name = '';
        this.FormFieldModel.name = this.Name();
        this.startListenToAlertState();
        this.startListenToTextChange();
        if (this.FieldType() == FormFieldTypes.TxtBox)
            this.configMask();
    }
    onTxtChange() {
        //this.FormFielTxtModel.value está mudando no template pelo ngModel
        this.FormFieldModel.name = this.Name();
        this.FormFieldModel.field = this.FormFielTxtModel;
        this.FormFieldModel.internalCall = true;
        this.FormFieldService.valueChanged.next(this.FormFieldModel);
    }
    onComboChange() {
        //this.FormFielComboModel.value está mudando no template pelo ngModel
        this.FormFieldModel.name = this.Name();
        this.FormFieldComboModel.id = this.getIDFromOption(this.FormFieldComboModel.value);
        this.FormFieldModel.field = this.FormFieldComboModel;
        this.FormFieldModel.internalCall = true;
        this.FormFieldService.valueChanged.next(this.FormFieldModel);
    }
    startListenToTextChange() {
        this.FormFieldService.valueChanged.subscribe((model) => {
            if (model.name == this.Name() && !model.internalCall) {
                if (this.FieldType() == FormFieldTypes.TxtBox) {
                    this.FormFielTxtModel.value = model.field.value;
                    this.onTxtChange();
                }
                if (this.FieldType() == FormFieldTypes.ComboBox) {
                    for (let i = 0; i < this._Options().length; i++) {
                        if (this._Options()[i].value.includes(model.field.value)) {
                            this.FormFieldComboModel.value = this._Options()[i].value;
                            break;
                        }
                        this.FormFieldComboModel.value = '';
                    }
                    this.onComboChange();
                }
            }
        });
    }
    startListenToAlertState() {
        this.FormFieldService.alertState.subscribe((callerData) => {
            if (this.Name() == callerData.alertsFatherName) {
                callerData.top_DontSet = this.element.nativeElement.getBoundingClientRect().top - (this.element.nativeElement.offsetHeight * 1.5);
                callerData.left_DontSet = this.element.nativeElement.getBoundingClientRect().left;
                callerData.alertsName_DontSet = this.FormFieldModel.name + '-alert';
                this.AlertService.wasOpenned.next(callerData);
            }
        });
    }
    togglePasswordView() {
        if (this._PasswordIcon == FormFieldIconsEnum.EyeClose) {
            this._PasswordIcon = FormFieldIconsEnum.EyeOpen;
            this._placeHolderType = 'password';
        }
        else {
            this._PasswordIcon = FormFieldIconsEnum.EyeClose;
            this._placeHolderType = 'text';
        }
    }
    configMask() {
        switch (this.TxtInputType()) {
            case (FormFieldTxtInputTypesEnum.Text):
                this._placeHolderType = 'text';
                this.Prefixo = "";
                this.Mask = "";
                this.Sufixo = "";
                this.showMaskTyped = false;
                break;
            case (FormFieldTxtInputTypesEnum.Password):
                this._placeHolderType = 'password';
                this.Prefixo = "";
                this.Mask = "";
                this.Sufixo = "";
                this.showMaskTyped = false;
                break;
            case (FormFieldTxtInputTypesEnum.Email):
                this._placeHolderType = 'text';
                this.Prefixo = "";
                this.Mask = "";
                this.Sufixo = "";
                this.showMaskTyped = false;
                break;
            case (FormFieldTxtInputTypesEnum.Number):
                this._placeHolderType = 'text';
                this.Prefixo = "";
                this.Mask = "separator." + this.NCasasDecimais().toString();
                this.Sufixo = this.NumberMaskSufix();
                this.showMaskTyped = false;
                if (this.CountryDataFormat() == FormFieldCountryDataFormat.Brasil) {
                    this.thousandSeparator = ".";
                }
                if (this.CountryDataFormat() == FormFieldCountryDataFormat.Estados_Unidos) {
                    this.thousandSeparator = ",";
                }
                break;
            case (FormFieldTxtInputTypesEnum.Date):
                this._placeHolderType = 'date';
                this.Prefixo = "";
                this.Mask = "";
                this.Sufixo = "";
                this.showMaskTyped = true;
                break;
            case (FormFieldTxtInputTypesEnum.DateTime):
                this._placeHolderType = 'datetime-local';
                this.Prefixo = "";
                this.Mask = "";
                this.Sufixo = "";
                this.showMaskTyped = true;
                break;
            case (FormFieldTxtInputTypesEnum.CellPhone):
                this._placeHolderType = 'tel';
                this.showMaskTyped = true;
                if (this.CountryDataFormat() == FormFieldCountryDataFormat.Brasil) {
                    this.Prefixo = "+55 ";
                    this.Mask = "(00) 0 0000-0000";
                }
                if (this.CountryDataFormat() == FormFieldCountryDataFormat.Estados_Unidos) {
                    this.Prefixo = "+1 ";
                    this.Mask = "(000) 000-0000";
                }
                break;
        }
    }
    getIDFromOption(valueText) {
        for (var i = 0; i < this._Options().length; i++) {
            if (valueText == this._Options()[i].value)
                return this._Options()[i].id;
        }
        return 0;
    }
    enterPressed() {
        this.FormFieldModel.name = this.Name();
        this.FormFieldService.enterPressed.next(this.FormFieldModel);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: FormFieldComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.0", type: FormFieldComponent, isStandalone: true, selector: "app-form-field", inputs: { _Icon: { classPropertyName: "_Icon", publicName: "_Icon", isSignal: true, isRequired: true, transformFunction: null }, Name: { classPropertyName: "Name", publicName: "Name", isSignal: true, isRequired: true, transformFunction: null }, _placeHolderValue: { classPropertyName: "_placeHolderValue", publicName: "_placeHolderValue", isSignal: true, isRequired: true, transformFunction: null }, _IconColor: { classPropertyName: "_IconColor", publicName: "_IconColor", isSignal: true, isRequired: true, transformFunction: null }, _FontColor: { classPropertyName: "_FontColor", publicName: "_FontColor", isSignal: true, isRequired: true, transformFunction: null }, _FontSize: { classPropertyName: "_FontSize", publicName: "_FontSize", isSignal: true, isRequired: true, transformFunction: null }, _FontFamily: { classPropertyName: "_FontFamily", publicName: "_FontFamily", isSignal: true, isRequired: true, transformFunction: null }, _FontWeight: { classPropertyName: "_FontWeight", publicName: "_FontWeight", isSignal: true, isRequired: true, transformFunction: null }, _Options: { classPropertyName: "_Options", publicName: "_Options", isSignal: true, isRequired: true, transformFunction: null }, _Width: { classPropertyName: "_Width", publicName: "_Width", isSignal: true, isRequired: true, transformFunction: null }, _Height: { classPropertyName: "_Height", publicName: "_Height", isSignal: true, isRequired: true, transformFunction: null }, TxtInputType: { classPropertyName: "TxtInputType", publicName: "TxtInputType", isSignal: true, isRequired: true, transformFunction: null }, IconEnabled: { classPropertyName: "IconEnabled", publicName: "IconEnabled", isSignal: true, isRequired: true, transformFunction: null }, CountryDataFormat: { classPropertyName: "CountryDataFormat", publicName: "CountryDataFormat", isSignal: true, isRequired: true, transformFunction: null }, FieldType: { classPropertyName: "FieldType", publicName: "FieldType", isSignal: true, isRequired: true, transformFunction: null }, NumberMaskSufix: { classPropertyName: "NumberMaskSufix", publicName: "NumberMaskSufix", isSignal: true, isRequired: true, transformFunction: null }, NCasasDecimais: { classPropertyName: "NCasasDecimais", publicName: "NCasasDecimais", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0, template: "\r\n@if(FieldType() == FormFieldTypes.TxtBox){\r\n\r\n    <div class=\"container\" \r\n    [style.width]=\"_Width() +'px'\"\r\n    [style.height]=\"_Height() +'px'\"\r\n    [style.border-radius]=\"(_FontSize()*0.3125) +'px'\"\r\n    [ngStyle]=\"\r\n    {'box-shadow':'\r\n    rgb(204, 219, 232)'+ (_FontSize()*0.1875) + 'px '+ (_FontSize()*0.1875)  + 'px '+ (_FontSize()*0.375) + 'px 0px inset' + ',' + \r\n    'rgba(255, 255, 255, 0.5)'+ (_FontSize()*-0.1875) + 'px '+ (_FontSize()*-0.1875)  + 'px '+ (_FontSize()*0.375) + 'px '+ (_FontSize()*0.0625) + 'px inset'\r\n    }\r\n    \">\r\n\r\n        <i class=\"{{_Icon()}} icon\"\r\n        [style.color]=\"_IconColor()\"\r\n        [style.font-size]=\"(_FontSize()*1.25) +'px'\"\r\n        [style.margin-left]=\"(_FontSize()*0.5625) +'px'\"\r\n        [style.display]=\"IconEnabled() ? '' : 'none'\"\r\n        ></i>\r\n\r\n        <input\r\n\r\n            [(ngModel)]=\"this.FormFielTxtModel.value\"\r\n            (ngModelChange)=\"onTxtChange()\"\r\n            prefix=\"{{Prefixo}}\"\r\n            suffix=\"{{Sufixo}}\"\r\n            mask=\"{{Mask}}\"\r\n            [showMaskTyped]=\"showMaskTyped\"\r\n            [allowNegativeNumbers]=\"TxtInputType() == FormFieldTxtInputTypesEnum.Number ? true : false\"\r\n            thousandSeparator=\"{{thousandSeparator}}\"\r\n            (keydown.enter)=\"enterPressed()\"\r\n\r\n            type=\"{{_placeHolderType}}\"\r\n            name=\"{{Name()}}\"\r\n            placeholder=\"{{_placeHolderValue()}}\"\r\n            [style.color]=\"_FontColor()\"\r\n            [style.font-family]=\"_FontFamily()\"\r\n            [style.font-size]=\"_FontSize()+'px'\"\r\n            [style.font-weight]=\"_FontWeight()\"\r\n            [style.width]=\"(_FontSize()*15.3125) +'px'\"\r\n            [style.margin-left]=\"(_FontSize()*0.500) +'px'\"\r\n        >\r\n\r\n        <i class=\"{{_PasswordIcon}}\"\r\n        (click)=\"togglePasswordView()\"\r\n        [style.cursor]=\"'pointer'\"\r\n        [style.color]=\"_IconColor()\"\r\n        [style.font-size]=\"(_FontSize()*1.25) +'px'\"\r\n        [style.margin-right]=\"(_FontSize()*0.5625) +'px'\"\r\n        [style.display]=\"TxtInputType() == FormFieldTxtInputTypesEnum.Password ? '' : 'none'\"\r\n        ></i>\r\n    </div>\r\n}@else {\r\n\r\n    <div class=\"container\"\r\n    [style.width]=\"_Width() +'px'\"\r\n    [style.height]=\"_Height() +'px'\"\r\n    [style.padding]=\"(_FontSize()*0.4) +'px' + ' ' + (_FontSize()*0.8) +'px'\" \r\n    [style.border-radius]=\"(_FontSize()*0.3125) +'px'\"\r\n    [ngStyle]=\"\r\n    {'box-shadow':'\r\n    rgb(204, 219, 232)'+ (_FontSize()*0.1875) + 'px '+ (_FontSize()*0.1875)  + 'px '+ (_FontSize()*0.375) + 'px 0px inset' + ',' + \r\n    'rgba(255, 255, 255, 0.5)'+ (_FontSize()*-0.1875) + 'px '+ (_FontSize()*-0.1875)  + 'px '+ (_FontSize()*0.375) + 'px '+ (_FontSize()*0.0625) + 'px inset'\r\n    }\r\n    \">\r\n        <select\r\n        [(ngModel)]=\"this.FormFieldComboModel.value\"\r\n        (ngModelChange)=\"onComboChange()\"\r\n        [style.color]=\"_FontColor()\"\r\n        [style.font-family]=\"_FontFamily()\"\r\n        [style.font-size]=\"_FontSize()+'px'\"\r\n        [style.font-weight]=\"_FontWeight()\"\r\n        [style.width]=\"_Width() +'px'\"\r\n        [style.height]=\"_Height() +'px'\"\r\n\r\n        >\r\n            @for(option of _Options() ; track $index ){\r\n                <option>{{option.value}}</option>\r\n            }\r\n        </select>\r\n    </div>\r\n}\r\n\r\n\r\n<app-alert\r\n[Name]=\"Name()+'-alert'\"\r\n[_FontSize]=\"_FontSize()\"\r\n[_FontFamily]=\"_FontFamily()\"\r\n[_FontWeight]=\"_FontWeight()\"\r\n/>\r\n\r\n\r\n\r\n\r\n", styles: [":host{display:inline-block}.container{display:flex;align-items:center;box-sizing:border-box}i{line-height:0px}input,select{background-color:transparent;border:none;padding:0}input,select:focus{outline:none;box-sizing:content-box}select{height:100%}select:hover{cursor:pointer}\n"], dependencies: [{ kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i1.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: AlertComponent, selector: "app-alert", inputs: ["Name", "_FontSize", "_FontFamily", "_FontWeight"] }, { kind: "directive", type: i3.NgxMaskDirective, selector: "input[mask], textarea[mask]", inputs: ["mask", "specialCharacters", "patterns", "prefix", "suffix", "thousandSeparator", "decimalMarker", "dropSpecialCharacters", "hiddenInput", "showMaskTyped", "placeHolderCharacter", "shownMaskExpression", "clearIfNotMatch", "validation", "separatorLimit", "allowNegativeNumbers", "leadZeroDateTime", "leadZero", "triggerOnMaskChange", "apm", "inputTransformFn", "outputTransformFn", "keepCharacterPositions", "instantPrefix"], outputs: ["maskFilled"], exportAs: ["mask", "ngxMask"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: FormFieldComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-form-field', standalone: true, imports: [FormsModule, CommonModule, AlertComponent, i3.NgxMaskDirective], template: "\r\n@if(FieldType() == FormFieldTypes.TxtBox){\r\n\r\n    <div class=\"container\" \r\n    [style.width]=\"_Width() +'px'\"\r\n    [style.height]=\"_Height() +'px'\"\r\n    [style.border-radius]=\"(_FontSize()*0.3125) +'px'\"\r\n    [ngStyle]=\"\r\n    {'box-shadow':'\r\n    rgb(204, 219, 232)'+ (_FontSize()*0.1875) + 'px '+ (_FontSize()*0.1875)  + 'px '+ (_FontSize()*0.375) + 'px 0px inset' + ',' + \r\n    'rgba(255, 255, 255, 0.5)'+ (_FontSize()*-0.1875) + 'px '+ (_FontSize()*-0.1875)  + 'px '+ (_FontSize()*0.375) + 'px '+ (_FontSize()*0.0625) + 'px inset'\r\n    }\r\n    \">\r\n\r\n        <i class=\"{{_Icon()}} icon\"\r\n        [style.color]=\"_IconColor()\"\r\n        [style.font-size]=\"(_FontSize()*1.25) +'px'\"\r\n        [style.margin-left]=\"(_FontSize()*0.5625) +'px'\"\r\n        [style.display]=\"IconEnabled() ? '' : 'none'\"\r\n        ></i>\r\n\r\n        <input\r\n\r\n            [(ngModel)]=\"this.FormFielTxtModel.value\"\r\n            (ngModelChange)=\"onTxtChange()\"\r\n            prefix=\"{{Prefixo}}\"\r\n            suffix=\"{{Sufixo}}\"\r\n            mask=\"{{Mask}}\"\r\n            [showMaskTyped]=\"showMaskTyped\"\r\n            [allowNegativeNumbers]=\"TxtInputType() == FormFieldTxtInputTypesEnum.Number ? true : false\"\r\n            thousandSeparator=\"{{thousandSeparator}}\"\r\n            (keydown.enter)=\"enterPressed()\"\r\n\r\n            type=\"{{_placeHolderType}}\"\r\n            name=\"{{Name()}}\"\r\n            placeholder=\"{{_placeHolderValue()}}\"\r\n            [style.color]=\"_FontColor()\"\r\n            [style.font-family]=\"_FontFamily()\"\r\n            [style.font-size]=\"_FontSize()+'px'\"\r\n            [style.font-weight]=\"_FontWeight()\"\r\n            [style.width]=\"(_FontSize()*15.3125) +'px'\"\r\n            [style.margin-left]=\"(_FontSize()*0.500) +'px'\"\r\n        >\r\n\r\n        <i class=\"{{_PasswordIcon}}\"\r\n        (click)=\"togglePasswordView()\"\r\n        [style.cursor]=\"'pointer'\"\r\n        [style.color]=\"_IconColor()\"\r\n        [style.font-size]=\"(_FontSize()*1.25) +'px'\"\r\n        [style.margin-right]=\"(_FontSize()*0.5625) +'px'\"\r\n        [style.display]=\"TxtInputType() == FormFieldTxtInputTypesEnum.Password ? '' : 'none'\"\r\n        ></i>\r\n    </div>\r\n}@else {\r\n\r\n    <div class=\"container\"\r\n    [style.width]=\"_Width() +'px'\"\r\n    [style.height]=\"_Height() +'px'\"\r\n    [style.padding]=\"(_FontSize()*0.4) +'px' + ' ' + (_FontSize()*0.8) +'px'\" \r\n    [style.border-radius]=\"(_FontSize()*0.3125) +'px'\"\r\n    [ngStyle]=\"\r\n    {'box-shadow':'\r\n    rgb(204, 219, 232)'+ (_FontSize()*0.1875) + 'px '+ (_FontSize()*0.1875)  + 'px '+ (_FontSize()*0.375) + 'px 0px inset' + ',' + \r\n    'rgba(255, 255, 255, 0.5)'+ (_FontSize()*-0.1875) + 'px '+ (_FontSize()*-0.1875)  + 'px '+ (_FontSize()*0.375) + 'px '+ (_FontSize()*0.0625) + 'px inset'\r\n    }\r\n    \">\r\n        <select\r\n        [(ngModel)]=\"this.FormFieldComboModel.value\"\r\n        (ngModelChange)=\"onComboChange()\"\r\n        [style.color]=\"_FontColor()\"\r\n        [style.font-family]=\"_FontFamily()\"\r\n        [style.font-size]=\"_FontSize()+'px'\"\r\n        [style.font-weight]=\"_FontWeight()\"\r\n        [style.width]=\"_Width() +'px'\"\r\n        [style.height]=\"_Height() +'px'\"\r\n\r\n        >\r\n            @for(option of _Options() ; track $index ){\r\n                <option>{{option.value}}</option>\r\n            }\r\n        </select>\r\n    </div>\r\n}\r\n\r\n\r\n<app-alert\r\n[Name]=\"Name()+'-alert'\"\r\n[_FontSize]=\"_FontSize()\"\r\n[_FontFamily]=\"_FontFamily()\"\r\n[_FontWeight]=\"_FontWeight()\"\r\n/>\r\n\r\n\r\n\r\n\r\n", styles: [":host{display:inline-block}.container{display:flex;align-items:center;box-sizing:border-box}i{line-height:0px}input,select{background-color:transparent;border:none;padding:0}input,select:focus{outline:none;box-sizing:content-box}select{height:100%}select:hover{cursor:pointer}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }] });

var ButtonTypeEnum;
(function (ButtonTypeEnum) {
    ButtonTypeEnum["Button"] = "button";
    ButtonTypeEnum["Menu"] = "menu";
    ButtonTypeEnum["Reset"] = "reset";
    ButtonTypeEnum["Submit"] = "submit";
})(ButtonTypeEnum || (ButtonTypeEnum = {}));
var ButtonIconPositionEnum;
(function (ButtonIconPositionEnum) {
    ButtonIconPositionEnum[ButtonIconPositionEnum["Top"] = 0] = "Top";
    ButtonIconPositionEnum[ButtonIconPositionEnum["Right"] = 1] = "Right";
    ButtonIconPositionEnum[ButtonIconPositionEnum["Bottom"] = 2] = "Bottom";
    ButtonIconPositionEnum[ButtonIconPositionEnum["Left"] = 3] = "Left";
})(ButtonIconPositionEnum || (ButtonIconPositionEnum = {}));
var ButtonIconEnum;
(function (ButtonIconEnum) {
    ButtonIconEnum["AddUser"] = "fi fi-sr-user-add";
    ButtonIconEnum["User"] = "fi fi-sr-user";
    ButtonIconEnum["Lock"] = "fi fi-sr-lock";
    ButtonIconEnum["EyeOpen"] = "fi fi-ss-eye";
    ButtonIconEnum["EyeClose"] = "fi fi-ss-eye-crossed";
    ButtonIconEnum["ItemClosed"] = "fi fi-tr-caret-down";
    ButtonIconEnum["ItemOpenned"] = "fi fi-rr-caret-down";
    ButtonIconEnum["Done_Fill"] = "fi fi-sr-octagon-check";
    ButtonIconEnum["Done_OutLine"] = "fi fi-rr-check-circle";
    ButtonIconEnum["Doing_Pending_Outline"] = "fi fi-br-duration-alt";
    ButtonIconEnum["Doing_Pending_Fill"] = "fi fi-ss-duration-alt";
    ButtonIconEnum["NotDone"] = "fi fi-sr-cross-circle";
    ButtonIconEnum["Alert"] = "fi fi-sr-exclamation";
    ButtonIconEnum["Close"] = "fi fi-br-cross";
    ButtonIconEnum["Home"] = "fi fi-sr-home";
    ButtonIconEnum["Key"] = "fi fi-sr-key";
    ButtonIconEnum["Company"] = "fi fi-rs-building";
    ButtonIconEnum["NoteBook"] = "fi fi-br-notebook-alt";
    ButtonIconEnum["AddFile"] = "fi fi-rr-add-document";
    ButtonIconEnum["PageGoBack"] = "fi fi-rr-angle-circle-left";
    ButtonIconEnum["PDFFile"] = "fi fi-sr-file-pdf";
    ButtonIconEnum["DowloadFile"] = "fi fi-sr-file-download";
    ButtonIconEnum["Phone"] = "fi fi-sr-phone-call";
    ButtonIconEnum["Edit"] = "fi fi-sr-pencil";
    ButtonIconEnum["Delete"] = "fi fi-sr-trash";
    ButtonIconEnum["Rotas"] = "fi fi-br-route";
    ButtonIconEnum["Hamburger"] = "fi fi-br-menu-burger";
    ButtonIconEnum["Lubrificacao"] = "fi fi-rr-oil-can";
})(ButtonIconEnum || (ButtonIconEnum = {}));
var ButtonFontWeights;
(function (ButtonFontWeights) {
    ButtonFontWeights[ButtonFontWeights["Thin"] = 100] = "Thin";
    ButtonFontWeights[ButtonFontWeights["ExtraLight"] = 200] = "ExtraLight";
    ButtonFontWeights[ButtonFontWeights["Light"] = 300] = "Light";
    ButtonFontWeights[ButtonFontWeights["Regular"] = 400] = "Regular";
    ButtonFontWeights[ButtonFontWeights["Medium"] = 500] = "Medium";
    ButtonFontWeights[ButtonFontWeights["SemiBold"] = 600] = "SemiBold";
    ButtonFontWeights[ButtonFontWeights["Bold"] = 700] = "Bold";
    ButtonFontWeights[ButtonFontWeights["Extrabold"] = 800] = "Extrabold";
    ButtonFontWeights[ButtonFontWeights["Black"] = 900] = "Black";
})(ButtonFontWeights || (ButtonFontWeights = {}));

class ButtonService {
    constructor() {
        this.click = new Subject();
        this.loadingState = new Subject();
        this.alertState = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ButtonService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ButtonService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ButtonService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class ButtonModel {
    constructor() {
        this.name = '';
        this.state = false;
    }
}

class LabelModel {
    constructor() {
        this.name = '';
    }
}

class LabelService {
    constructor() {
        this.stateChanger = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: LabelService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: LabelService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: LabelService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class ButtonComponent {
    ;
    constructor(element) {
        this.element = element;
        this._BackGroundColor = '';
        this._ButtonType = input.required();
        this._BorderRadius = input.required();
        this._Width = input.required();
        this._Height = input.required();
        this._Icon = input.required();
        this._IconFontSize = 0;
        this._IconOrientation = '';
        this._IconMarginType = '';
        this._IconDistanceFromTextObject = {};
        this._IconColor = '';
        this._IconDistanceFromText = input.required();
        this._IconEnabled = input.required();
        this._TextColor = '';
        this._Text = input.required();
        this._FontSize = input.required();
        this._FontWeight = input.required();
        this._TextFontFamily = input.required();
        this._TextEnabled = input.required();
        this.name = input.required();
        this.BackGroundColorNormal = input.required();
        this.BackGroundColorHover = input.required();
        this.IconColorNormal = input.required();
        this.IconColorHover = input.required();
        this.TextColorNormal = input.required();
        this.TextColorHover = input.required();
        this.IconOrientation = input.required();
        this._LoadingState = false;
        this._AlertState = false;
        this.ButtonModel = new ButtonModel();
        this.ButtonService = inject(ButtonService);
        this.AlertService = inject(AlertService);
        this.FormFieldService = inject(FormFieldService);
        this.AlertModel = new AlertModel();
        this.LabelService = inject(LabelService);
        this.LabelModel = new LabelModel();
        this.AlertTypesEnum = AlertTypesEnum;
    }
    ngOnInit() {
        //Limpa as Memórias de Estado
        this._BackGroundColor = '';
        this._IconColor = '';
        this._TextColor = '';
        this._IconDistanceFromTextObject = {};
        this._IconFontSize = 0;
        this._IconOrientation = '';
        this.ButtonModel = new ButtonModel();
        this._LoadingState = false;
        this._AlertState = false;
        this.ngStyle = {};
        this._BackGroundColor = this.BackGroundColorNormal();
        this._IconColor = this.IconColorNormal();
        this._TextColor = this.TextColorNormal();
        this._IconFontSize = this._FontSize() * 1.25;
        this.startListenToLoadingState();
        this.startListenToAlertState();
        switch (this.IconOrientation()) {
            case (ButtonIconPositionEnum.Top):
                this._IconOrientation = 'column';
                this._IconDistanceFromTextObject = this._TextEnabled() ? { 'margin-bottom': this._IconDistanceFromText().toString() + 'px' } : {};
                break;
            case (ButtonIconPositionEnum.Right):
                this._IconOrientation = 'row-reverse';
                this._IconDistanceFromTextObject = this._TextEnabled() ? { 'margin-left': this._IconDistanceFromText().toString() + 'px' } : {};
                break;
            case (ButtonIconPositionEnum.Bottom):
                this._IconOrientation = 'column-reverse';
                this._IconDistanceFromTextObject = this._TextEnabled() ? { 'margin-top': this._IconDistanceFromText().toString() + 'px' } : {};
                break;
            case (ButtonIconPositionEnum.Left):
                this._IconDistanceFromTextObject = this._TextEnabled() ? { 'margin-right': this._IconDistanceFromText().toString() + 'px' } : {};
                break;
        }
        this.ngStyle = {
            'box-shadow': (this._FontSize() / 8) + 'px' + (this._FontSize() / 4) + 'px' + (this._FontSize() / 4) + 'px' + '0px' + 'rgba(0, 0, 0, 0.25)',
            'flex-direction': this._IconOrientation
        };
    }
    OnMouseOver() {
        this._BackGroundColor = this.BackGroundColorHover();
        this._IconColor = this.IconColorHover();
        this._TextColor = this.TextColorHover();
    }
    OnMouseOut() {
        this._BackGroundColor = this.BackGroundColorNormal();
        this._IconColor = this.IconColorNormal();
        this._TextColor = this.TextColorNormal();
    }
    OnClick() {
        this.ButtonModel.name = this.name();
        this.ButtonModel.state = true;
        this.ButtonService.click.next(this.ButtonModel);
        this.ButtonService.loadingState.next(this.ButtonModel);
    }
    startListenToLoadingState() {
        this.ButtonService.loadingState.subscribe((callerData) => {
            if (this.name() == callerData.name) {
                this._LoadingState = callerData.state;
            }
        });
    }
    startListenToAlertState() {
        this.FormFieldService.alertState.subscribe((callerData) => {
            if (this.name() == callerData.alertsFatherName) {
                callerData.top_DontSet = this.element.nativeElement.getBoundingClientRect().top - this.element.nativeElement.offsetHeight;
                callerData.left_DontSet = this.element.nativeElement.getBoundingClientRect().left + this.element.nativeElement.offsetWidth;
                callerData.alertsName_DontSet = this.ButtonModel.name + '-alert';
                this.AlertService.wasOpenned.next(callerData);
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ButtonComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.2.0", type: ButtonComponent, isStandalone: true, selector: "app-button", inputs: { _ButtonType: { classPropertyName: "_ButtonType", publicName: "_ButtonType", isSignal: true, isRequired: true, transformFunction: null }, _BorderRadius: { classPropertyName: "_BorderRadius", publicName: "_BorderRadius", isSignal: true, isRequired: true, transformFunction: null }, _Width: { classPropertyName: "_Width", publicName: "_Width", isSignal: true, isRequired: true, transformFunction: null }, _Height: { classPropertyName: "_Height", publicName: "_Height", isSignal: true, isRequired: true, transformFunction: null }, _Icon: { classPropertyName: "_Icon", publicName: "_Icon", isSignal: true, isRequired: true, transformFunction: null }, _IconDistanceFromText: { classPropertyName: "_IconDistanceFromText", publicName: "_IconDistanceFromText", isSignal: true, isRequired: true, transformFunction: null }, _IconEnabled: { classPropertyName: "_IconEnabled", publicName: "_IconEnabled", isSignal: true, isRequired: true, transformFunction: null }, _Text: { classPropertyName: "_Text", publicName: "_Text", isSignal: true, isRequired: true, transformFunction: null }, _FontSize: { classPropertyName: "_FontSize", publicName: "_FontSize", isSignal: true, isRequired: true, transformFunction: null }, _FontWeight: { classPropertyName: "_FontWeight", publicName: "_FontWeight", isSignal: true, isRequired: true, transformFunction: null }, _TextFontFamily: { classPropertyName: "_TextFontFamily", publicName: "_TextFontFamily", isSignal: true, isRequired: true, transformFunction: null }, _TextEnabled: { classPropertyName: "_TextEnabled", publicName: "_TextEnabled", isSignal: true, isRequired: true, transformFunction: null }, name: { classPropertyName: "name", publicName: "name", isSignal: true, isRequired: true, transformFunction: null }, BackGroundColorNormal: { classPropertyName: "BackGroundColorNormal", publicName: "BackGroundColorNormal", isSignal: true, isRequired: true, transformFunction: null }, BackGroundColorHover: { classPropertyName: "BackGroundColorHover", publicName: "BackGroundColorHover", isSignal: true, isRequired: true, transformFunction: null }, IconColorNormal: { classPropertyName: "IconColorNormal", publicName: "IconColorNormal", isSignal: true, isRequired: true, transformFunction: null }, IconColorHover: { classPropertyName: "IconColorHover", publicName: "IconColorHover", isSignal: true, isRequired: true, transformFunction: null }, TextColorNormal: { classPropertyName: "TextColorNormal", publicName: "TextColorNormal", isSignal: true, isRequired: true, transformFunction: null }, TextColorHover: { classPropertyName: "TextColorHover", publicName: "TextColorHover", isSignal: true, isRequired: true, transformFunction: null }, IconOrientation: { classPropertyName: "IconOrientation", publicName: "IconOrientation", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0, template: "\r\n<button\r\ntype=\"{{_ButtonType()}}\"\r\n[style.background-color]=\"_BackGroundColor\"\r\n[style.border-radius]=\"_BorderRadius().toString()+'px'\"\r\n[style.width]=\"_Width()+ 'px'\"\r\n[style.height]=\"_Height()+ 'px'\"\r\n[ngStyle]=\"ngStyle\"\r\n(mouseover)=\"OnMouseOver()\"\r\n(mouseout)=\"OnMouseOut()\"\r\n(click)=\"OnClick()\"\r\n\r\n>\r\n    \r\n        <i\r\n            class=\"{{_Icon()}}\"\r\n            [style.color]=\"_IconColor\"\r\n            [style.font-size]=\"_IconFontSize +'px'\"\r\n            [style.display]=\"_IconEnabled() && !_LoadingState ? '' : 'none'\"\r\n            [ngStyle]=\"_IconDistanceFromTextObject\"\r\n            >\r\n        </i>\r\n\r\n        <i\r\n        class=\"loader\"\r\n        [style.width]=\"_FontSize()+'px'\"\r\n        [style.height]=\"_FontSize()+'px'\"\r\n        [style.display]=\"_LoadingState ? 'inline-block' : 'none'\"\r\n        [style.--loaderColor]=\"_TextColor\"\r\n        [style.--loaderBorderSize]=\"(_FontSize()*0.15)+'px'\"\r\n        >\r\n        </i>\r\n\r\n        <p\r\n        [style.font-size]=\"_FontSize() +'px'\"\r\n        [style.font-family]=\"_TextFontFamily()\"\r\n        [style.font-weight]=\"_FontWeight()\"\r\n        [style.color]=\"_TextColor\"\r\n        [style.display]=\"_TextEnabled() && !_LoadingState ? '' : 'none'\"\r\n        >{{_Text()}}\r\n        </p>\r\n\r\n</button>\r\n<app-alert\r\n[Name]=\"name()+'-alert'\"\r\n[_FontSize]=\"_FontSize()\"\r\n[_FontFamily]=\"_TextFontFamily()\"\r\n[_FontWeight]=\"_FontWeight()\"\r\n/>\r\n    \r\n", styles: [":host{display:inline-block;vertical-align:top;line-height:0px}button{display:flex;align-items:center;justify-content:center;border:none;padding:0;text-decoration:none;box-shadow:2px 4px 4px #00000040}button:hover{cursor:pointer;transition:.05s;transform:scale(1.05)}button:active{transform:scale(.95)}button>i{line-height:0px}button>p{margin:0;line-height:0px}button>.loader{border:var(--loaderBorderSize) solid var(--loaderColor);border-bottom-color:transparent;border-radius:50%;box-sizing:border-box;animation:rotation 1s linear infinite}@keyframes rotation{0%{transform:rotate(0)}to{transform:rotate(360deg)}}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: AlertComponent, selector: "app-alert", inputs: ["Name", "_FontSize", "_FontFamily", "_FontWeight"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-button', standalone: true, imports: [CommonModule, AlertComponent], template: "\r\n<button\r\ntype=\"{{_ButtonType()}}\"\r\n[style.background-color]=\"_BackGroundColor\"\r\n[style.border-radius]=\"_BorderRadius().toString()+'px'\"\r\n[style.width]=\"_Width()+ 'px'\"\r\n[style.height]=\"_Height()+ 'px'\"\r\n[ngStyle]=\"ngStyle\"\r\n(mouseover)=\"OnMouseOver()\"\r\n(mouseout)=\"OnMouseOut()\"\r\n(click)=\"OnClick()\"\r\n\r\n>\r\n    \r\n        <i\r\n            class=\"{{_Icon()}}\"\r\n            [style.color]=\"_IconColor\"\r\n            [style.font-size]=\"_IconFontSize +'px'\"\r\n            [style.display]=\"_IconEnabled() && !_LoadingState ? '' : 'none'\"\r\n            [ngStyle]=\"_IconDistanceFromTextObject\"\r\n            >\r\n        </i>\r\n\r\n        <i\r\n        class=\"loader\"\r\n        [style.width]=\"_FontSize()+'px'\"\r\n        [style.height]=\"_FontSize()+'px'\"\r\n        [style.display]=\"_LoadingState ? 'inline-block' : 'none'\"\r\n        [style.--loaderColor]=\"_TextColor\"\r\n        [style.--loaderBorderSize]=\"(_FontSize()*0.15)+'px'\"\r\n        >\r\n        </i>\r\n\r\n        <p\r\n        [style.font-size]=\"_FontSize() +'px'\"\r\n        [style.font-family]=\"_TextFontFamily()\"\r\n        [style.font-weight]=\"_FontWeight()\"\r\n        [style.color]=\"_TextColor\"\r\n        [style.display]=\"_TextEnabled() && !_LoadingState ? '' : 'none'\"\r\n        >{{_Text()}}\r\n        </p>\r\n\r\n</button>\r\n<app-alert\r\n[Name]=\"name()+'-alert'\"\r\n[_FontSize]=\"_FontSize()\"\r\n[_FontFamily]=\"_TextFontFamily()\"\r\n[_FontWeight]=\"_FontWeight()\"\r\n/>\r\n    \r\n", styles: [":host{display:inline-block;vertical-align:top;line-height:0px}button{display:flex;align-items:center;justify-content:center;border:none;padding:0;text-decoration:none;box-shadow:2px 4px 4px #00000040}button:hover{cursor:pointer;transition:.05s;transform:scale(1.05)}button:active{transform:scale(.95)}button>i{line-height:0px}button>p{margin:0;line-height:0px}button>.loader{border:var(--loaderBorderSize) solid var(--loaderColor);border-bottom-color:transparent;border-radius:50%;box-sizing:border-box;animation:rotation 1s linear infinite}@keyframes rotation{0%{transform:rotate(0)}to{transform:rotate(360deg)}}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }] });

var ListItemIcons;
(function (ListItemIcons) {
    ListItemIcons["AddUser"] = "fi fi-sr-user-add";
    ListItemIcons["User"] = "fi fi-sr-user";
    ListItemIcons["Lock"] = "fi fi-sr-lock";
    ListItemIcons["EyeOpen"] = "fi fi-ss-eye";
    ListItemIcons["EyeClose"] = "fi fi-ss-eye-crossed";
    ListItemIcons["ItemClosed"] = "fi fi-tr-caret-down";
    ListItemIcons["ItemOpenned"] = "fi fi-rr-caret-down";
    ListItemIcons["Done_Fill"] = "fi fi-sr-octagon-check";
    ListItemIcons["Done_OutLine"] = "fi fi-rr-check-circle";
    ListItemIcons["Doing_Pending_Outline"] = "fi fi-br-duration-alt";
    ListItemIcons["Doing_Pending_Fill"] = "fi fi-ss-duration-alt";
    ListItemIcons["NotDone"] = "fi fi-sr-cross-circle";
    ListItemIcons["Alert"] = "fi fi-sr-exclamation";
    ListItemIcons["Close"] = "fi fi-br-cross";
    ListItemIcons["Home"] = "fi fi-sr-home";
    ListItemIcons["Key"] = "fi fi-sr-key";
    ListItemIcons["Company"] = "fi fi-rs-building";
    ListItemIcons["NoteBook"] = "fi fi-br-notebook-alt";
    ListItemIcons["AddFile"] = "fi fi-rr-add-document";
    ListItemIcons["PageGoBack"] = "fi fi-rr-angle-circle-left";
    ListItemIcons["PDFFile"] = "fi fi-sr-file-pdf";
    ListItemIcons["DowloadFile"] = "fi fi-sr-file-download";
    ListItemIcons["Phone"] = "fi fi-sr-phone-call";
    ListItemIcons["Edit"] = "fi fi-sr-pencil";
    ListItemIcons["Delete"] = "fi fi-sr-trash";
    ListItemIcons["Rotas"] = "fi fi-br-route";
    ListItemIcons["Hamburger"] = "fi fi-br-menu-burger";
    ListItemIcons["Lubrificacao"] = "fi fi-rr-oil-can";
})(ListItemIcons || (ListItemIcons = {}));
var ListItemPositions;
(function (ListItemPositions) {
    ListItemPositions[ListItemPositions["Top"] = 0] = "Top";
    ListItemPositions[ListItemPositions["Center"] = 1] = "Center";
})(ListItemPositions || (ListItemPositions = {}));
var ListItemFontWeights;
(function (ListItemFontWeights) {
    ListItemFontWeights[ListItemFontWeights["Thin"] = 100] = "Thin";
    ListItemFontWeights[ListItemFontWeights["ExtraLight"] = 200] = "ExtraLight";
    ListItemFontWeights[ListItemFontWeights["Light"] = 300] = "Light";
    ListItemFontWeights[ListItemFontWeights["Regular"] = 400] = "Regular";
    ListItemFontWeights[ListItemFontWeights["Medium"] = 500] = "Medium";
    ListItemFontWeights[ListItemFontWeights["SemiBold"] = 600] = "SemiBold";
    ListItemFontWeights[ListItemFontWeights["Bold"] = 700] = "Bold";
    ListItemFontWeights[ListItemFontWeights["Extrabold"] = 800] = "Extrabold";
    ListItemFontWeights[ListItemFontWeights["Black"] = 900] = "Black";
})(ListItemFontWeights || (ListItemFontWeights = {}));

class ListItemService {
    constructor() {
        this.stateChanged = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ListItemService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ListItemService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ListItemService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class ListItemModel {
    constructor() {
        this.name = '';
    }
}
class ListItemStateModel {
    constructor() {
        this.OpenState = false;
    }
}

class ListItemComponent {
    constructor() {
        this.Name = input.required();
        this._BoxShadowEnabled = input.required();
        //Wrapper
        this._BorderRadius = 0;
        //Container
        this._ItemBackGroundColorNormal = input.required();
        this._ItemBackGroundColorHover = input.required();
        //IconContainer
        this._IconBackgroundColor = '';
        //ItemNumber
        this._ItemNumberEnabled = input.required();
        this._ItemNumberText = input.required();
        this._ItemNumberFontFamily = input.required();
        this._ItemNumberFontWeight = input.required();
        this._ItemNumberFontColor = input.required();
        this._ItemNumberPosition = input.required();
        this._ItemNumberMarginTop = 0;
        this._ItemNumberMarginLeft = 0;
        this._ItemNumberMarginRight = 0;
        //IconStatus]
        this._IconEnabled = input.required();
        this._IconMarginLeft = 0;
        this._IconMarginRight = 0;
        //TextContainer
        this._TextContainerMarginLeft = 0;
        this._TextContainerMarginRight = 0;
        this._TextBackgroundColor = '';
        //Title
        this._TitleText = '';
        this._TitleFontFamily = input.required();
        this._TitleFontColor = input.required();
        this._TitleFontWeight = input.required();
        this._TitleEnabled = true;
        //SubTitle
        this._SubTitleEnabled = false;
        this._SubTitleText = '';
        this._SubTitleFontFamily = input.required();
        this._SubTitleFontColor = input.required();
        this._SubTitleFontWeight = input.required();
        //IconOpenContainer
        this._IconOpenBackgroundColor = '';
        //iconOpenItem
        this._IconOpenItemColor = input.required();
        this._IconOpenItemEnabled = true;
        //Wrapped
        this._WrappedBackGroundColor = '';
        this._FontSize = input.required();
        //Internals
        this._ListItemIcons = ListItemIcons;
        this.ListItePositions = ListItemPositions;
        this.ItemStateOpen = false;
        this.ListItemService = inject(ListItemService);
        this.ButtonService = inject(ButtonService);
    }
    ngOnInit() {
        this.ButtonModel = new ButtonModel();
        this.startListenToStateChange();
        //Zera Memorias
        this._ItemNumberMarginTop = 0;
        this._ItemNumberMarginLeft = 0;
        this._ItemNumberMarginRight = 0;
        this._IconMarginLeft = 0;
        this._IconMarginRight = 0;
        this._TextContainerMarginLeft = 0;
        if (this._ItemNumberEnabled()) {
            this._ItemNumberMarginTop = this._ItemNumberPosition() == this.ListItePositions.Top ? (this._FontSize() * 0.5) : ((this._FontSize() * 3.777 / 2) - this._FontSize() / 2);
            this._ItemNumberMarginLeft = this._FontSize() * 0.5;
            this._ItemNumberMarginRight = this._FontSize() * 0.361;
            this._IconMarginLeft = this._FontSize() * 0.361;
            this._IconMarginRight = this._FontSize() * 0.361;
            this._TextContainerMarginLeft = this._FontSize() * 0.722;
        }
        else {
            if (this._IconEnabled()) {
                this._IconMarginLeft = this._FontSize() * 1.2;
                this._IconMarginRight = this._FontSize() * 1.2;
                this._TextContainerMarginLeft = this._FontSize() * 0.722;
            }
            else {
                this._TextContainerMarginLeft = this._FontSize() * 2;
            }
        }
    }
    OnClick() {
        let model = new ListItemModel();
        let modelState = new ListItemStateModel();
        model.name = this.Name();
        if (this.ItemStateOpen) {
            modelState.OpenState = false;
        }
        else {
            modelState.OpenState = true;
        }
        model.state = modelState;
        this.ListItemService.stateChanged.next(model);
    }
    startListenToStateChange() {
        this.ListItemService.stateChanged.subscribe((model) => {
            if (this.Name() == model.name) {
                this._TitleEnabled = model.state.TitleEnabled != undefined ? model.state.TitleEnabled : this._TitleEnabled;
                this._TitleText = model.state.TitleText != undefined ? model.state.TitleText : this._TitleText;
                this._SubTitleEnabled = model.state.SubTitleEnabled != undefined ? model.state.SubTitleEnabled : this._SubTitleEnabled;
                this._SubTitleText = model.state.SubTitleText != undefined ? model.state.SubTitleText : this._SubTitleText;
                this._IconOpenItemEnabled = model.state.IconOpenItemEnabled != undefined ? model.state.IconOpenItemEnabled : this._IconOpenItemEnabled;
                this._Width = model.state.Width != undefined ? model.state.Width : this._Width;
                this._Icon = model.state.Icon != undefined ? model.state.Icon : this._Icon;
                this._IconColor = model.state.IconColor != undefined ? model.state.IconColor : this._IconColor;
                this._IconBackgroundColor = model.state.IconBackGroundColor != undefined ? model.state.IconBackGroundColor : this._IconBackgroundColor;
                this._TextBackgroundColor = model.state.TextBackGroundColor != undefined ? model.state.TextBackGroundColor : this._TextBackgroundColor;
                this._IconOpenBackgroundColor = model.state.IconOpenBackGroundColor != undefined ? model.state.IconOpenBackGroundColor : this._IconOpenBackgroundColor;
                this._WrappedBackGroundColor = model.state.WrappedBackGroundColor != undefined ? model.state.WrappedBackGroundColor : this._WrappedBackGroundColor;
                this._BorderRadius = model.state.BorderRadius != undefined ? model.state.BorderRadius : this._BorderRadius;
                this.ItemStateOpen = model.state.OpenState != undefined ? model.state.OpenState : this.ItemStateOpen;
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ListItemComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.2.0", type: ListItemComponent, isStandalone: true, selector: "app-list-item", inputs: { Name: { classPropertyName: "Name", publicName: "Name", isSignal: true, isRequired: true, transformFunction: null }, _BoxShadowEnabled: { classPropertyName: "_BoxShadowEnabled", publicName: "_BoxShadowEnabled", isSignal: true, isRequired: true, transformFunction: null }, _ItemBackGroundColorNormal: { classPropertyName: "_ItemBackGroundColorNormal", publicName: "_ItemBackGroundColorNormal", isSignal: true, isRequired: true, transformFunction: null }, _ItemBackGroundColorHover: { classPropertyName: "_ItemBackGroundColorHover", publicName: "_ItemBackGroundColorHover", isSignal: true, isRequired: true, transformFunction: null }, _ItemNumberEnabled: { classPropertyName: "_ItemNumberEnabled", publicName: "_ItemNumberEnabled", isSignal: true, isRequired: true, transformFunction: null }, _ItemNumberText: { classPropertyName: "_ItemNumberText", publicName: "_ItemNumberText", isSignal: true, isRequired: true, transformFunction: null }, _ItemNumberFontFamily: { classPropertyName: "_ItemNumberFontFamily", publicName: "_ItemNumberFontFamily", isSignal: true, isRequired: true, transformFunction: null }, _ItemNumberFontWeight: { classPropertyName: "_ItemNumberFontWeight", publicName: "_ItemNumberFontWeight", isSignal: true, isRequired: true, transformFunction: null }, _ItemNumberFontColor: { classPropertyName: "_ItemNumberFontColor", publicName: "_ItemNumberFontColor", isSignal: true, isRequired: true, transformFunction: null }, _ItemNumberPosition: { classPropertyName: "_ItemNumberPosition", publicName: "_ItemNumberPosition", isSignal: true, isRequired: true, transformFunction: null }, _IconEnabled: { classPropertyName: "_IconEnabled", publicName: "_IconEnabled", isSignal: true, isRequired: true, transformFunction: null }, _TitleFontFamily: { classPropertyName: "_TitleFontFamily", publicName: "_TitleFontFamily", isSignal: true, isRequired: true, transformFunction: null }, _TitleFontColor: { classPropertyName: "_TitleFontColor", publicName: "_TitleFontColor", isSignal: true, isRequired: true, transformFunction: null }, _TitleFontWeight: { classPropertyName: "_TitleFontWeight", publicName: "_TitleFontWeight", isSignal: true, isRequired: true, transformFunction: null }, _SubTitleFontFamily: { classPropertyName: "_SubTitleFontFamily", publicName: "_SubTitleFontFamily", isSignal: true, isRequired: true, transformFunction: null }, _SubTitleFontColor: { classPropertyName: "_SubTitleFontColor", publicName: "_SubTitleFontColor", isSignal: true, isRequired: true, transformFunction: null }, _SubTitleFontWeight: { classPropertyName: "_SubTitleFontWeight", publicName: "_SubTitleFontWeight", isSignal: true, isRequired: true, transformFunction: null }, _IconOpenItemColor: { classPropertyName: "_IconOpenItemColor", publicName: "_IconOpenItemColor", isSignal: true, isRequired: true, transformFunction: null }, _FontSize: { classPropertyName: "_FontSize", publicName: "_FontSize", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0, template: "\r\n<div class=\"wrapper\"\r\n[style.width]=\"_Width+'px'\"\r\n[class.box-shadow]=\"_BoxShadowEnabled()\"\r\n[style.border-radius]=\"_BorderRadius+'px'\"\r\n>\r\n    <div class=\"container\"\r\n    (click)=\"OnClick()\"\r\n    >\r\n\r\n        <div class=\"iconContainer\"\r\n        [style.background-color]=\"_IconBackgroundColor\"\r\n        [style.max-width]=\"_Width+'px'\"\r\n        >\r\n            <p class=\"ItemNumber\"\r\n            [style.display]=\"_ItemNumberEnabled() ? '' : 'none'\"\r\n            [style.font-family]=\"_ItemNumberFontFamily()\"\r\n            [style.font-weight]=\"_ItemNumberFontWeight()\"\r\n            [style.color]=\"_ItemNumberFontColor()\"\r\n            [style.font-size]=\"_ItemNumberPosition() == ListItePositions.Top ? (_FontSize()*0.833)+'px' : (_FontSize())+'px'  \"\r\n            [style.margin-top]=\"_ItemNumberMarginTop +'px'\"\r\n            [style.margin-left]=\"_ItemNumberMarginLeft+'px'\"\r\n            [style.margin-right]=\"_ItemNumberMarginRight+'px'\"\r\n            >\r\n                {{_ItemNumberText()}}\r\n            </p>\r\n\r\n            <i class=\"{{_Icon}}\"\r\n            [style.display]=\"_IconEnabled() ? '' : 'none'\"\r\n            [style.color]=\"_IconColor\"\r\n            [style.font-size]=\"(_FontSize()*1.111)+'px'\"\r\n            [style.margin-left]=\"_IconMarginLeft+'px'\"\r\n            [style.margin-right]=\"_IconMarginRight+'px'\"\r\n            ></i>\r\n        </div>\r\n\r\n\r\n        <div class=\"TextContainer\"\r\n        [style.padding-top]=\"_FontSize()+'px'\"\r\n        [style.padding-bottom]=\"_FontSize()+'px'\"\r\n        [style.padding-left]=\"_FontSize()+'px'\"\r\n        [style.background-color]=\"_TextBackgroundColor\"\r\n        >\r\n\r\n            <h1 class=\"title\"\r\n            [style.font-family]=\"_TitleFontFamily()\"\r\n            [style.color]=\"_TitleFontColor()\"\r\n            [style.font-size]=\"_FontSize()+'px'\"\r\n            [style.font-weight]=\"_TitleFontWeight()\"\r\n            [style.display]=\"_TitleEnabled ? '' : 'none'\"\r\n            >\r\n                {{_TitleText}}\r\n            </h1>\r\n\r\n            <h2 class=\"sub-title\"\r\n            [style.display]=\"_SubTitleEnabled ? '' : 'none'\"\r\n            [style.font-family]=\"_SubTitleFontFamily()\"\r\n            [style.color]=\"_SubTitleFontColor()\"\r\n            [style.font-size]=\"(_FontSize()*0.833)+'px'\"\r\n            [style.font-weight]=\"_SubTitleFontWeight()\"\r\n            >\r\n                {{_SubTitleText}}\r\n            </h2>\r\n\r\n        </div>\r\n\r\n        <div class=\"ItemOpenIconContainer\"\r\n        [style.background-color]=\"_IconOpenBackgroundColor\"\r\n        >\r\n            <i class=\"{{ItemStateOpen? _ListItemIcons.ItemOpenned : _ListItemIcons.ItemClosed}} ItemOpenState ItemOpenIcon\"\r\n            [style.display]=\"_IconOpenItemEnabled ? '' : 'none'\"\r\n            [style.margin-left]=\"_IconMarginLeft+'px'\"\r\n            [style.margin-right]=\"_IconMarginRight+'px'\"\r\n            [class.ItemOpenState]=\"ItemStateOpen\"\r\n            [class.ItemCloseState]=\"!ItemStateOpen\"\r\n            [style.color]=\"_IconOpenItemColor()\"\r\n            [style.font-size]=\"(_FontSize()*1.666)+'px'\"\r\n            ></i>\r\n        </div>\r\n\r\n\r\n    </div>\r\n    <div class=\"containerWrapped\"\r\n    [style.background-color]=\"_WrappedBackGroundColor\"\r\n    [style.display]=\"ItemStateOpen ? '' : 'none'\"\r\n    [style.padding-left]=\"_IconMarginLeft+'px'\"\r\n    [style.padding-right]=\"_IconMarginRight+'px'\"\r\n    >\r\n        <ng-content/>\r\n    </div>\r\n\r\n\r\n</div>\r\n\r\n", styles: [":host{display:inline-block;vertical-align:top}.wrapper{overflow:hidden}.box-shadow{box-shadow:#0000003d 0 3px 8px}.wrapper>.container{display:flex;cursor:pointer}.wrapper>.container>.iconContainer{display:flex;flex-direction:column;align-items:center;justify-content:center}.wrapper>.container>.iconContainer>p{margin:0}.wrapper>.container>.iconContainer>i{line-height:0px;display:flex;align-items:center;justify-content:center}.wrapper>.container>.TextContainer{display:flex;flex-direction:column;align-items:start;justify-content:center;width:100%}.wrapper>.container>.TextContainer>h1,h2{margin:0;text-align:center}.wrapper>.container>.ItemOpenIconContainer{display:flex;flex-direction:column;align-items:center;justify-content:center}.wrapper>.container>.ItemOpenIconContainer>.ItemOpenState{transition:.3s}.wrapper>.container>.ItemOpenIconContainer>.ItemCloseState{transform:rotate(90deg);transition:.3s}.wrapper>.containerWrapped{border-top:1px solid rgba(0,0,0,.24)}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ListItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-list-item', standalone: true, imports: [], template: "\r\n<div class=\"wrapper\"\r\n[style.width]=\"_Width+'px'\"\r\n[class.box-shadow]=\"_BoxShadowEnabled()\"\r\n[style.border-radius]=\"_BorderRadius+'px'\"\r\n>\r\n    <div class=\"container\"\r\n    (click)=\"OnClick()\"\r\n    >\r\n\r\n        <div class=\"iconContainer\"\r\n        [style.background-color]=\"_IconBackgroundColor\"\r\n        [style.max-width]=\"_Width+'px'\"\r\n        >\r\n            <p class=\"ItemNumber\"\r\n            [style.display]=\"_ItemNumberEnabled() ? '' : 'none'\"\r\n            [style.font-family]=\"_ItemNumberFontFamily()\"\r\n            [style.font-weight]=\"_ItemNumberFontWeight()\"\r\n            [style.color]=\"_ItemNumberFontColor()\"\r\n            [style.font-size]=\"_ItemNumberPosition() == ListItePositions.Top ? (_FontSize()*0.833)+'px' : (_FontSize())+'px'  \"\r\n            [style.margin-top]=\"_ItemNumberMarginTop +'px'\"\r\n            [style.margin-left]=\"_ItemNumberMarginLeft+'px'\"\r\n            [style.margin-right]=\"_ItemNumberMarginRight+'px'\"\r\n            >\r\n                {{_ItemNumberText()}}\r\n            </p>\r\n\r\n            <i class=\"{{_Icon}}\"\r\n            [style.display]=\"_IconEnabled() ? '' : 'none'\"\r\n            [style.color]=\"_IconColor\"\r\n            [style.font-size]=\"(_FontSize()*1.111)+'px'\"\r\n            [style.margin-left]=\"_IconMarginLeft+'px'\"\r\n            [style.margin-right]=\"_IconMarginRight+'px'\"\r\n            ></i>\r\n        </div>\r\n\r\n\r\n        <div class=\"TextContainer\"\r\n        [style.padding-top]=\"_FontSize()+'px'\"\r\n        [style.padding-bottom]=\"_FontSize()+'px'\"\r\n        [style.padding-left]=\"_FontSize()+'px'\"\r\n        [style.background-color]=\"_TextBackgroundColor\"\r\n        >\r\n\r\n            <h1 class=\"title\"\r\n            [style.font-family]=\"_TitleFontFamily()\"\r\n            [style.color]=\"_TitleFontColor()\"\r\n            [style.font-size]=\"_FontSize()+'px'\"\r\n            [style.font-weight]=\"_TitleFontWeight()\"\r\n            [style.display]=\"_TitleEnabled ? '' : 'none'\"\r\n            >\r\n                {{_TitleText}}\r\n            </h1>\r\n\r\n            <h2 class=\"sub-title\"\r\n            [style.display]=\"_SubTitleEnabled ? '' : 'none'\"\r\n            [style.font-family]=\"_SubTitleFontFamily()\"\r\n            [style.color]=\"_SubTitleFontColor()\"\r\n            [style.font-size]=\"(_FontSize()*0.833)+'px'\"\r\n            [style.font-weight]=\"_SubTitleFontWeight()\"\r\n            >\r\n                {{_SubTitleText}}\r\n            </h2>\r\n\r\n        </div>\r\n\r\n        <div class=\"ItemOpenIconContainer\"\r\n        [style.background-color]=\"_IconOpenBackgroundColor\"\r\n        >\r\n            <i class=\"{{ItemStateOpen? _ListItemIcons.ItemOpenned : _ListItemIcons.ItemClosed}} ItemOpenState ItemOpenIcon\"\r\n            [style.display]=\"_IconOpenItemEnabled ? '' : 'none'\"\r\n            [style.margin-left]=\"_IconMarginLeft+'px'\"\r\n            [style.margin-right]=\"_IconMarginRight+'px'\"\r\n            [class.ItemOpenState]=\"ItemStateOpen\"\r\n            [class.ItemCloseState]=\"!ItemStateOpen\"\r\n            [style.color]=\"_IconOpenItemColor()\"\r\n            [style.font-size]=\"(_FontSize()*1.666)+'px'\"\r\n            ></i>\r\n        </div>\r\n\r\n\r\n    </div>\r\n    <div class=\"containerWrapped\"\r\n    [style.background-color]=\"_WrappedBackGroundColor\"\r\n    [style.display]=\"ItemStateOpen ? '' : 'none'\"\r\n    [style.padding-left]=\"_IconMarginLeft+'px'\"\r\n    [style.padding-right]=\"_IconMarginRight+'px'\"\r\n    >\r\n        <ng-content/>\r\n    </div>\r\n\r\n\r\n</div>\r\n\r\n", styles: [":host{display:inline-block;vertical-align:top}.wrapper{overflow:hidden}.box-shadow{box-shadow:#0000003d 0 3px 8px}.wrapper>.container{display:flex;cursor:pointer}.wrapper>.container>.iconContainer{display:flex;flex-direction:column;align-items:center;justify-content:center}.wrapper>.container>.iconContainer>p{margin:0}.wrapper>.container>.iconContainer>i{line-height:0px;display:flex;align-items:center;justify-content:center}.wrapper>.container>.TextContainer{display:flex;flex-direction:column;align-items:start;justify-content:center;width:100%}.wrapper>.container>.TextContainer>h1,h2{margin:0;text-align:center}.wrapper>.container>.ItemOpenIconContainer{display:flex;flex-direction:column;align-items:center;justify-content:center}.wrapper>.container>.ItemOpenIconContainer>.ItemOpenState{transition:.3s}.wrapper>.container>.ItemOpenIconContainer>.ItemCloseState{transform:rotate(90deg);transition:.3s}.wrapper>.containerWrapped{border-top:1px solid rgba(0,0,0,.24)}\n"] }]
        }] });

var LabelIconPositionEnum;
(function (LabelIconPositionEnum) {
    LabelIconPositionEnum[LabelIconPositionEnum["Top"] = 0] = "Top";
    LabelIconPositionEnum[LabelIconPositionEnum["Right"] = 1] = "Right";
    LabelIconPositionEnum[LabelIconPositionEnum["Bottom"] = 2] = "Bottom";
    LabelIconPositionEnum[LabelIconPositionEnum["Left"] = 3] = "Left";
})(LabelIconPositionEnum || (LabelIconPositionEnum = {}));
var LabelIconEnum;
(function (LabelIconEnum) {
    LabelIconEnum["AddUser"] = "fi fi-sr-user-add";
    LabelIconEnum["User"] = "fi fi-sr-user";
    LabelIconEnum["Lock"] = "fi fi-sr-lock";
    LabelIconEnum["EyeOpen"] = "fi fi-ss-eye";
    LabelIconEnum["EyeClose"] = "fi fi-ss-eye-crossed";
    LabelIconEnum["ItemClosed"] = "fi fi-tr-caret-down";
    LabelIconEnum["ItemOpenned"] = "fi fi-rr-caret-down";
    LabelIconEnum["Done_Fill"] = "fi fi-sr-octagon-check";
    LabelIconEnum["Done_OutLine"] = "fi fi-rr-check-circle";
    LabelIconEnum["Doing_Pending_Outline"] = "fi fi-br-duration-alt";
    LabelIconEnum["Doing_Pending_Fill"] = "fi fi-ss-duration-alt";
    LabelIconEnum["NotDone"] = "fi fi-sr-cross-circle";
    LabelIconEnum["Alert"] = "fi fi-sr-exclamation";
    LabelIconEnum["Close"] = "fi fi-br-cross";
    LabelIconEnum["Home"] = "fi fi-sr-home";
    LabelIconEnum["Key"] = "fi fi-sr-key";
    LabelIconEnum["Company"] = "fi fi-rs-building";
    LabelIconEnum["NoteBook"] = "fi fi-br-notebook-alt";
    LabelIconEnum["AddFile"] = "fi fi-rr-add-document";
    LabelIconEnum["PageGoBack"] = "fi fi-rr-angle-circle-left";
    LabelIconEnum["PDFFile"] = "fi fi-sr-file-pdf";
    LabelIconEnum["DowloadFile"] = "fi fi-sr-file-download";
    LabelIconEnum["Phone"] = "fi fi-sr-phone-call";
    LabelIconEnum["Edit"] = "fi fi-sr-pencil";
    LabelIconEnum["Delete"] = "fi fi-sr-trash";
    LabelIconEnum["Rotas"] = "fi fi-br-route";
    LabelIconEnum["Hamburger"] = "fi fi-br-menu-burger";
    LabelIconEnum["Lubrificacao"] = "fi fi-rr-oil-can";
})(LabelIconEnum || (LabelIconEnum = {}));
var LabelFontWeights;
(function (LabelFontWeights) {
    LabelFontWeights[LabelFontWeights["Thin"] = 100] = "Thin";
    LabelFontWeights[LabelFontWeights["ExtraLight"] = 200] = "ExtraLight";
    LabelFontWeights[LabelFontWeights["Light"] = 300] = "Light";
    LabelFontWeights[LabelFontWeights["Regular"] = 400] = "Regular";
    LabelFontWeights[LabelFontWeights["Medium"] = 500] = "Medium";
    LabelFontWeights[LabelFontWeights["SemiBold"] = 600] = "SemiBold";
    LabelFontWeights[LabelFontWeights["Bold"] = 700] = "Bold";
    LabelFontWeights[LabelFontWeights["Extrabold"] = 800] = "Extrabold";
    LabelFontWeights[LabelFontWeights["Black"] = 900] = "Black";
})(LabelFontWeights || (LabelFontWeights = {}));

class LabelComponent {
    constructor() {
        this.Name = input.required();
        this._IconEnabled = input.required();
        this._Icon = input.required();
        this._IconColor = input.required();
        this.IconOrientation = input.required();
        this.IconDistanceFromText = input.required();
        this._TextEnabled = input.required();
        this._TextFontFamily = input.required();
        this._Text = input.required();
        this._TextColor = input.required();
        this._TextFontWeight = input.required();
        this._TextFontSize = input.required();
        this.LabelService = inject(LabelService);
    }
    ngOnInit() {
        this.LabelModel = new LabelModel();
        this.setIconOrientationOnTemplate();
    }
    setIconOrientationOnTemplate() {
        switch (this.IconOrientation()) {
            case (LabelIconPositionEnum.Top):
                this._IconOrientation = 'column';
                this._IconDistanceFromTextObject = this._TextEnabled() ? { 'margin-bottom': this.IconDistanceFromText().toString() + 'px' } : {};
                break;
            case (LabelIconPositionEnum.Right):
                this._IconOrientation = 'row-reverse';
                this._IconDistanceFromTextObject = this._TextEnabled() ? { 'margin-left': this.IconDistanceFromText().toString() + 'px' } : {};
                break;
            case (LabelIconPositionEnum.Bottom):
                this._IconOrientation = 'column-reverse';
                this._IconDistanceFromTextObject = this._TextEnabled() ? { 'margin-top': this.IconDistanceFromText().toString() + 'px' } : {};
                break;
            case (LabelIconPositionEnum.Left):
                this._IconDistanceFromTextObject = this._TextEnabled() ? { 'margin-right': this.IconDistanceFromText().toString() + 'px' } : {};
                break;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: LabelComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.2.0", type: LabelComponent, isStandalone: true, selector: "app-label", inputs: { Name: { classPropertyName: "Name", publicName: "Name", isSignal: true, isRequired: true, transformFunction: null }, _IconEnabled: { classPropertyName: "_IconEnabled", publicName: "_IconEnabled", isSignal: true, isRequired: true, transformFunction: null }, _Icon: { classPropertyName: "_Icon", publicName: "_Icon", isSignal: true, isRequired: true, transformFunction: null }, _IconColor: { classPropertyName: "_IconColor", publicName: "_IconColor", isSignal: true, isRequired: true, transformFunction: null }, IconOrientation: { classPropertyName: "IconOrientation", publicName: "IconOrientation", isSignal: true, isRequired: true, transformFunction: null }, IconDistanceFromText: { classPropertyName: "IconDistanceFromText", publicName: "IconDistanceFromText", isSignal: true, isRequired: true, transformFunction: null }, _TextEnabled: { classPropertyName: "_TextEnabled", publicName: "_TextEnabled", isSignal: true, isRequired: true, transformFunction: null }, _TextFontFamily: { classPropertyName: "_TextFontFamily", publicName: "_TextFontFamily", isSignal: true, isRequired: true, transformFunction: null }, _Text: { classPropertyName: "_Text", publicName: "_Text", isSignal: true, isRequired: true, transformFunction: null }, _TextColor: { classPropertyName: "_TextColor", publicName: "_TextColor", isSignal: true, isRequired: true, transformFunction: null }, _TextFontWeight: { classPropertyName: "_TextFontWeight", publicName: "_TextFontWeight", isSignal: true, isRequired: true, transformFunction: null }, _TextFontSize: { classPropertyName: "_TextFontSize", publicName: "_TextFontSize", isSignal: true, isRequired: true, transformFunction: null } }, ngImport: i0, template: "<div class=\"container\"\r\n[ngStyle]=\"{'flex-direction':_IconOrientation}\"\r\n>\r\n\r\n    <i\r\n    class=\"{{_Icon()}}\"\r\n    [style.color]=\"_IconColor()\"\r\n    [style.font-size]=\"(_TextFontSize() *1.25)+'px'\"\r\n    [style.display]=\"_IconEnabled() ? '' : 'none'\"\r\n    [ngStyle]=\"_IconDistanceFromTextObject\"\r\n    >\r\n    </i>\r\n\r\n\r\n    <p\r\n    [style.font-size]=\"_TextFontSize() +'px'\"\r\n    [style.font-family]=\"_TextFontFamily()\"\r\n    [style.font-weight]=\"_TextFontWeight()\"\r\n    [style.color]=\"_TextColor()\"\r\n    [style.display]=\"_TextEnabled() ? '' : 'none'\"\r\n    >{{_Text()}}\r\n    </p>\r\n</div>", styles: [":host{display:inline-block}.container{display:flex;align-items:center;justify-content:center;border:none;padding:0}.container>i{line-height:0px}.container>p{margin:0;line-height:0px}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1$1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: LabelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-label', imports: [CommonModule], template: "<div class=\"container\"\r\n[ngStyle]=\"{'flex-direction':_IconOrientation}\"\r\n>\r\n\r\n    <i\r\n    class=\"{{_Icon()}}\"\r\n    [style.color]=\"_IconColor()\"\r\n    [style.font-size]=\"(_TextFontSize() *1.25)+'px'\"\r\n    [style.display]=\"_IconEnabled() ? '' : 'none'\"\r\n    [ngStyle]=\"_IconDistanceFromTextObject\"\r\n    >\r\n    </i>\r\n\r\n\r\n    <p\r\n    [style.font-size]=\"_TextFontSize() +'px'\"\r\n    [style.font-family]=\"_TextFontFamily()\"\r\n    [style.font-weight]=\"_TextFontWeight()\"\r\n    [style.color]=\"_TextColor()\"\r\n    [style.display]=\"_TextEnabled() ? '' : 'none'\"\r\n    >{{_Text()}}\r\n    </p>\r\n</div>", styles: [":host{display:inline-block}.container{display:flex;align-items:center;justify-content:center;border:none;padding:0}.container>i{line-height:0px}.container>p{margin:0;line-height:0px}\n"] }]
        }] });

var TableFontWeights;
(function (TableFontWeights) {
    TableFontWeights[TableFontWeights["Thin"] = 100] = "Thin";
    TableFontWeights[TableFontWeights["ExtraLight"] = 200] = "ExtraLight";
    TableFontWeights[TableFontWeights["Light"] = 300] = "Light";
    TableFontWeights[TableFontWeights["Regular"] = 400] = "Regular";
    TableFontWeights[TableFontWeights["Medium"] = 500] = "Medium";
    TableFontWeights[TableFontWeights["SemiBold"] = 600] = "SemiBold";
    TableFontWeights[TableFontWeights["Bold"] = 700] = "Bold";
    TableFontWeights[TableFontWeights["Extrabold"] = 800] = "Extrabold";
    TableFontWeights[TableFontWeights["Black"] = 900] = "Black";
})(TableFontWeights || (TableFontWeights = {}));
var TableModes;
(function (TableModes) {
    TableModes[TableModes["ReadOnly"] = 0] = "ReadOnly";
    TableModes[TableModes["Display"] = 1] = "Display";
})(TableModes || (TableModes = {}));

class TableService {
    constructor() {
        this.dataChange = new Subject();
        this.rowOnSelect = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: TableService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: TableService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: TableService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class TableComponent {
    constructor() {
        this.destroy = new Subject();
        this.name = input.required();
        this.TableMode = input.required();
        this._FontFamily = input.required();
        this._FontSize = input.required();
        this._Header_FontColor = input.required();
        this._Header_FontWeight = input.required();
        this._Header_BackGroundColor = input.required();
        this._Body_FontColor = input.required();
        this._Body_FontWeight = input.required();
        this._Body_BackGroundColor01 = input.required();
        this._Body_BackGroundColor02 = input.required();
        this._Body_BackGroundColorHover = input.required();
        this._BorderVerticalON = input.required();
        this._BorderHorizontalON = input.required();
        this._BorderColor = input.required();
        this._BorderSize = input.required();
        this._ContainerWidth = input.required();
        this._ContainerHeight = input.required();
        this.NomeColunaJSONID = input.required();
        this.NomeColunasJSON = input.required();
        this.NomeColunasDisplay = input.required();
        this.UnidadesDeMedidaDasColunas = input.required();
        this.NCasasDecimaisDasColunas = input.required();
        this.TableService = inject(TableService);
        this.rowSelected = false;
        this.TableModes = TableModes;
    }
    ngAfterViewInit() {
        setTimeout(() => {
            for (var i = 0; i < this.nodes.length - 1; i++) {
                if (i % 2 == 0) {
                    this.nodes[i].style.background = this._Body_BackGroundColor01();
                }
                else {
                    this.nodes[i].style.background = this._Body_BackGroundColor02();
                }
            }
        }, 1000);
    }
    ngOnDestroy() {
        this.destroy.next(true);
    }
    ngOnInit() {
        this.startListenToDataChange();
    }
    startListenToDataChange() {
        this.TableService.dataChange.pipe(takeUntil(this.destroy)).subscribe((model) => {
            if (model.name == this.name()) {
                this.rowsOnMemory = JSON.parse(JSON.stringify(model.data));
                if (this.VerificarSeENecessarioDeletarColunasDeUmObjeto(model.data, this.NomeColunasDisplay())) {
                    var ObjetosComNovosNomes = this.MudaNomesDasPropriedadesDeUmObjeto(model.data, this.NomeColunasDisplay(), this.NomeColunasJSON());
                    var ObjetosArredondados = this.ListaDeObjetosComCamposNumericosArredondados(ObjetosComNovosNomes, this.NCasasDecimaisDasColunas());
                    var ObjetosComUnidadesDeMedida = this.ListaDeObjetosComUnidadesDeMedidas(ObjetosArredondados, this.UnidadesDeMedidaDasColunas());
                    this.rowsOnDisplay = ObjetosComUnidadesDeMedida;
                    this.headers = Object.keys(this.rowsOnDisplay[0]);
                }
                else {
                    this.rowsOnDisplay = model.data;
                    this.headers = Object.keys(this.rowsOnDisplay[0]);
                }
                this.nodes = this.tbody.nativeElement.childNodes;
            }
        });
    }
    OnLineSelected(row) {
        if (this.TableMode() == this.TableModes.Display) {
            this.nodeSelectedIndex = this.rowsOnDisplay.indexOf(row);
            var id = this.rowsOnMemory[this.nodeSelectedIndex][this.NomeColunaJSONID()];
            this.TableService.rowOnSelect.next(id);
            for (var i = 0; i < this.nodes.length - 1; i++) {
                if (i % 2 == 0) {
                    this.nodes[i].style.background = this._Body_BackGroundColor01();
                }
                else {
                    this.nodes[i].style.background = this._Body_BackGroundColor02();
                }
            }
            this.nodes[this.nodeSelectedIndex].style.background = this._Body_BackGroundColorHover();
        }
    }
    OnMouseEnter(row) {
        var index = this.rowsOnDisplay.indexOf(row);
        for (var i = 0; i < this.nodes.length - 1; i++) {
            if (i % 2 == 0 && i != this.nodeSelectedIndex) {
                this.nodes[i].style.background = this._Body_BackGroundColor01();
            }
            else if (i % 2 == 0 && i != this.nodeSelectedIndex) {
                this.nodes[i].style.background = this._Body_BackGroundColor02();
            }
            this.nodes[index].style.background = this._Body_BackGroundColorHover();
        }
    }
    OnMouseLeave(row) {
        for (var i = 0; i < this.nodes.length - 1; i++) {
            if (i % 2 == 0 && i != this.nodeSelectedIndex) {
                this.nodes[i].style.background = this._Body_BackGroundColor01();
            }
            else if (i % 2 != 0 && i != this.nodeSelectedIndex) {
                this.nodes[i].style.background = this._Body_BackGroundColor02();
            }
        }
    }
    VerificarSeENecessarioDeletarColunasDeUmObjeto(listaObjetos, ListaDeNovosNomes) {
        for (var i = 0; i < Object.keys(listaObjetos[0]).length; i++) {
            if (ListaDeNovosNomes.includes(Object.keys(listaObjetos[0])[i])) {
            }
            else {
                return true;
            }
        }
        return false;
    }
    MudaNomesDasPropriedadesDeUmObjeto(listaObjetos, ListaDeNovosNomes, ListaDeNomesAntigosParaManter) {
        var listaObjetosColunasDeletadas = this.DeletaPropriedadesDeCadaObjetoDeUmaLista(listaObjetos, ListaDeNomesAntigosParaManter);
        //Muda os nomes das colunas de acordo com configuração
        for (var z = 0; z < ListaDeNovosNomes.length; z++) {
            for (var y = 0; y < listaObjetosColunasDeletadas.length; y++) {
                listaObjetosColunasDeletadas[y][ListaDeNovosNomes[z]] = listaObjetosColunasDeletadas[y][ListaDeNomesAntigosParaManter[z]];
                delete listaObjetosColunasDeletadas[y][ListaDeNomesAntigosParaManter[z]];
            }
        }
        return listaObjetosColunasDeletadas;
    }
    DeletaPropriedadesDeCadaObjetoDeUmaLista(listaObjetos, ListaColunasParaManter) {
        const ListaColunasParaDeletar = this.ListaNomesColunasDeletadas(listaObjetos[0], ListaColunasParaManter);
        //Deleta propriedades do objeto que estão definidas na lista de configuração
        for (var i = 0; i < ListaColunasParaDeletar.length; i++) {
            listaObjetos.forEach((obj) => {
                delete obj[ListaColunasParaDeletar[i]];
            });
        }
        i = 0;
        return listaObjetos;
    }
    ListaNomesColunasDeletadas(objOriginal, ListaColunasParaManter) {
        var newArray = [];
        for (var i = 0; i < Object.keys(objOriginal).length; i++) {
            if (ListaColunasParaManter.includes(Object.keys(objOriginal)[i])) {
            }
            else {
                newArray.push(Object.keys(objOriginal)[i]);
            }
        }
        i = 0;
        return newArray;
    }
    ListaDeObjetosComUnidadesDeMedidas(listaObjetos, listaUnidadesMedida) {
        for (var i = 0; i < listaObjetos.length; i++) {
            for (var y = 0; y < Object.keys(listaObjetos[0]).length; y++) {
                listaObjetos[i][(Object.keys(listaObjetos[0]))[y]] = listaObjetos[i][(Object.keys(listaObjetos[0]))[y]] + listaUnidadesMedida[y];
            }
        }
        return listaObjetos;
    }
    ListaDeObjetosComCamposNumericosArredondados(listaObjetos, listadeArredondamentos) {
        for (var i = 0; i < listaObjetos.length; i++) {
            for (var y = 0; y < Object.keys(listaObjetos[0]).length; y++) {
                if (isNaN(listaObjetos[i][(Object.keys(listaObjetos[0]))[y]])) {
                }
                else {
                    listaObjetos[i][(Object.keys(listaObjetos[0]))[y]] = parseFloat(listaObjetos[i][(Object.keys(listaObjetos[0]))[y]]).toFixed(listadeArredondamentos[y]);
                }
            }
        }
        return listaObjetos;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: TableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.0", type: TableComponent, isStandalone: true, selector: "app-table", inputs: { name: { classPropertyName: "name", publicName: "name", isSignal: true, isRequired: true, transformFunction: null }, TableMode: { classPropertyName: "TableMode", publicName: "TableMode", isSignal: true, isRequired: true, transformFunction: null }, _FontFamily: { classPropertyName: "_FontFamily", publicName: "_FontFamily", isSignal: true, isRequired: true, transformFunction: null }, _FontSize: { classPropertyName: "_FontSize", publicName: "_FontSize", isSignal: true, isRequired: true, transformFunction: null }, _Header_FontColor: { classPropertyName: "_Header_FontColor", publicName: "_Header_FontColor", isSignal: true, isRequired: true, transformFunction: null }, _Header_FontWeight: { classPropertyName: "_Header_FontWeight", publicName: "_Header_FontWeight", isSignal: true, isRequired: true, transformFunction: null }, _Header_BackGroundColor: { classPropertyName: "_Header_BackGroundColor", publicName: "_Header_BackGroundColor", isSignal: true, isRequired: true, transformFunction: null }, _Body_FontColor: { classPropertyName: "_Body_FontColor", publicName: "_Body_FontColor", isSignal: true, isRequired: true, transformFunction: null }, _Body_FontWeight: { classPropertyName: "_Body_FontWeight", publicName: "_Body_FontWeight", isSignal: true, isRequired: true, transformFunction: null }, _Body_BackGroundColor01: { classPropertyName: "_Body_BackGroundColor01", publicName: "_Body_BackGroundColor01", isSignal: true, isRequired: true, transformFunction: null }, _Body_BackGroundColor02: { classPropertyName: "_Body_BackGroundColor02", publicName: "_Body_BackGroundColor02", isSignal: true, isRequired: true, transformFunction: null }, _Body_BackGroundColorHover: { classPropertyName: "_Body_BackGroundColorHover", publicName: "_Body_BackGroundColorHover", isSignal: true, isRequired: true, transformFunction: null }, _BorderVerticalON: { classPropertyName: "_BorderVerticalON", publicName: "_BorderVerticalON", isSignal: true, isRequired: true, transformFunction: null }, _BorderHorizontalON: { classPropertyName: "_BorderHorizontalON", publicName: "_BorderHorizontalON", isSignal: true, isRequired: true, transformFunction: null }, _BorderColor: { classPropertyName: "_BorderColor", publicName: "_BorderColor", isSignal: true, isRequired: true, transformFunction: null }, _BorderSize: { classPropertyName: "_BorderSize", publicName: "_BorderSize", isSignal: true, isRequired: true, transformFunction: null }, _ContainerWidth: { classPropertyName: "_ContainerWidth", publicName: "_ContainerWidth", isSignal: true, isRequired: true, transformFunction: null }, _ContainerHeight: { classPropertyName: "_ContainerHeight", publicName: "_ContainerHeight", isSignal: true, isRequired: true, transformFunction: null }, NomeColunaJSONID: { classPropertyName: "NomeColunaJSONID", publicName: "NomeColunaJSONID", isSignal: true, isRequired: true, transformFunction: null }, NomeColunasJSON: { classPropertyName: "NomeColunasJSON", publicName: "NomeColunasJSON", isSignal: true, isRequired: true, transformFunction: null }, NomeColunasDisplay: { classPropertyName: "NomeColunasDisplay", publicName: "NomeColunasDisplay", isSignal: true, isRequired: true, transformFunction: null }, UnidadesDeMedidaDasColunas: { classPropertyName: "UnidadesDeMedidaDasColunas", publicName: "UnidadesDeMedidaDasColunas", isSignal: true, isRequired: true, transformFunction: null }, NCasasDecimaisDasColunas: { classPropertyName: "NCasasDecimaisDasColunas", publicName: "NCasasDecimaisDasColunas", isSignal: true, isRequired: true, transformFunction: null } }, viewQueries: [{ propertyName: "tbody", first: true, predicate: ["tbody"], descendants: true }], ngImport: i0, template: "<div class=\"container\" style=\"overflow-x:auto;\"\r\n[style.width]=\"_ContainerWidth()+'px'\"\r\n[style.height]=\"_ContainerHeight()+'px'\"\r\n>\r\n    <table\r\n    [style.font-family]=\"_FontFamily()\"\r\n    [style.--padding]=\"(_FontSize()*0.5+'px')+' ' + (_FontSize()*0.625+'px')\"\r\n    [style.--borderLeft]=\"(_BorderVerticalON() ? _BorderSize()+'px' : '0px') + ' solid '+_BorderColor()\"\r\n    [style.--borderBottom]=\"(_BorderHorizontalON() ? _BorderSize()+'px' : '0px') + ' solid '+_BorderColor()\"\r\n    >\r\n    \r\n        <thead\r\n        [style.font-size]=\"_FontSize()*1.1 + 'px'\"\r\n        [style.font-weight]=\"_Header_FontWeight()\"\r\n        [style.background-color]=\"_Header_BackGroundColor()\"\r\n        [style.color]=\"_Header_FontColor()\"\r\n        >\r\n            <tr>\r\n                @for(_header of headers ; track $index){\r\n                    <th>{{_header}}</th>\r\n                }\r\n            </tr>\r\n        </thead>\r\n    \r\n        <tbody\r\n        #tbody\r\n        [style.font-size]=\"_FontSize() + 'px'\"\r\n        [style.font-weight]=\"_Body_FontWeight()\"\r\n        [style.--Body_FontColor]=\"_Body_FontColor()\"\r\n        [style.--Body_BackGroundColor01]=\"_Body_BackGroundColor01()\"\r\n        [style.--Body_BackGroundColor02]=\"_Body_BackGroundColor02()\"\r\n        [style.--Body_BackGroundColorHover]=\"_Body_BackGroundColorHover()\"\r\n        [style.cursor]=\"TableMode() == TableModes.ReadOnly ? 'default' : 'pointer'\"\r\n        >\r\n            @for(row of rowsOnDisplay ; track $index){\r\n                <tr\r\n                (click)=\"OnLineSelected(row)\"\r\n                (mouseenter)=\"OnMouseEnter(row)\"\r\n                (mouseleave)=\"OnMouseLeave(row)\"\r\n                >\r\n                    @for(_header of headers; track $index){\r\n                       <td\r\n                       \r\n                       >{{row[_header]}}</td>\r\n                    }\r\n                </tr>\r\n            }\r\n        </tbody>\r\n        \r\n    </table>\r\n</div>\r\n\r\n\r\n\r\n\r\n", styles: [".container{display:inline-block}table{border-collapse:collapse}tbody>tr:hover{background-color:var(--Body_BackGroundColorHover)}tbody>tr:nth-child(2n):hover{background-color:var(--Body_BackGroundColorHover)}td,th{text-align:center;border-left:var(--borderLeft);border-right:var(--borderLeft);border-bottom:var(--borderBottom);border-top:var(--borderBottom);vertical-align:middle;padding:var(--padding)}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: TableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-table', imports: [], template: "<div class=\"container\" style=\"overflow-x:auto;\"\r\n[style.width]=\"_ContainerWidth()+'px'\"\r\n[style.height]=\"_ContainerHeight()+'px'\"\r\n>\r\n    <table\r\n    [style.font-family]=\"_FontFamily()\"\r\n    [style.--padding]=\"(_FontSize()*0.5+'px')+' ' + (_FontSize()*0.625+'px')\"\r\n    [style.--borderLeft]=\"(_BorderVerticalON() ? _BorderSize()+'px' : '0px') + ' solid '+_BorderColor()\"\r\n    [style.--borderBottom]=\"(_BorderHorizontalON() ? _BorderSize()+'px' : '0px') + ' solid '+_BorderColor()\"\r\n    >\r\n    \r\n        <thead\r\n        [style.font-size]=\"_FontSize()*1.1 + 'px'\"\r\n        [style.font-weight]=\"_Header_FontWeight()\"\r\n        [style.background-color]=\"_Header_BackGroundColor()\"\r\n        [style.color]=\"_Header_FontColor()\"\r\n        >\r\n            <tr>\r\n                @for(_header of headers ; track $index){\r\n                    <th>{{_header}}</th>\r\n                }\r\n            </tr>\r\n        </thead>\r\n    \r\n        <tbody\r\n        #tbody\r\n        [style.font-size]=\"_FontSize() + 'px'\"\r\n        [style.font-weight]=\"_Body_FontWeight()\"\r\n        [style.--Body_FontColor]=\"_Body_FontColor()\"\r\n        [style.--Body_BackGroundColor01]=\"_Body_BackGroundColor01()\"\r\n        [style.--Body_BackGroundColor02]=\"_Body_BackGroundColor02()\"\r\n        [style.--Body_BackGroundColorHover]=\"_Body_BackGroundColorHover()\"\r\n        [style.cursor]=\"TableMode() == TableModes.ReadOnly ? 'default' : 'pointer'\"\r\n        >\r\n            @for(row of rowsOnDisplay ; track $index){\r\n                <tr\r\n                (click)=\"OnLineSelected(row)\"\r\n                (mouseenter)=\"OnMouseEnter(row)\"\r\n                (mouseleave)=\"OnMouseLeave(row)\"\r\n                >\r\n                    @for(_header of headers; track $index){\r\n                       <td\r\n                       \r\n                       >{{row[_header]}}</td>\r\n                    }\r\n                </tr>\r\n            }\r\n        </tbody>\r\n        \r\n    </table>\r\n</div>\r\n\r\n\r\n\r\n\r\n", styles: [".container{display:inline-block}table{border-collapse:collapse}tbody>tr:hover{background-color:var(--Body_BackGroundColorHover)}tbody>tr:nth-child(2n):hover{background-color:var(--Body_BackGroundColorHover)}td,th{text-align:center;border-left:var(--borderLeft);border-right:var(--borderLeft);border-bottom:var(--borderBottom);border-top:var(--borderBottom);vertical-align:middle;padding:var(--padding)}\n"] }]
        }], propDecorators: { tbody: [{
                type: ViewChild,
                args: ['tbody']
            }] } });

class TableModel {
    constructor() {
        this.name = '';
    }
}

class ModalService {
    constructor() {
        this.showModal = new Subject();
        this.ClosedByConfirmation = new Subject();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ModalService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ModalService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ModalService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class ModalModel {
    constructor(params) {
        this.OnlyOkButtonEnabled = false;
        this.BtnCancelName = '';
        this.BtnCancelText = '';
        this.BtnCancelWidth = 0;
        this.BtnCancelHeight = 0;
        this.BtnOkName = '';
        this.BtnOkText = '';
        this.BtnOkWidth = 0;
        this.BtnOkHeight = 0;
        this.BtnsFontSize = 0;
        this.ModalMessage = '';
        this.OnlyOkButtonEnabled = params.OnlyOkButtonEnabled;
        this.BtnCancelName = params.BtnCancelName;
        this.BtnCancelText = params.BtnCancelText;
        this.BtnCancelWidth = params.BtnCancelWidth;
        this.BtnCancelHeight = params.BtnCancelHeight;
        this.BtnOkName = params.BtnOkName;
        this.BtnOkText = params.BtnOkText;
        this.BtnOkWidth = params.BtnOkWidth;
        this.BtnOkHeight = params.BtnOkHeight;
        this.BtnsFontSize = params.BtnsFontSize;
        this.ModalMessage = params.ModalMessage;
    }
}

class ModalComponent {
    constructor() {
        this.ModalService = inject(ModalService);
        this.configModel = new ModalModel({
            OnlyOkButtonEnabled: false,
            BtnCancelName: '',
            BtnCancelText: '',
            BtnCancelWidth: 0,
            BtnCancelHeight: 0,
            BtnOkName: '',
            BtnOkText: '',
            BtnOkWidth: 0,
            BtnOkHeight: 0,
            BtnsFontSize: 0,
            ModalMessage: ''
        });
        this.isVisible = false;
        this._ButtonService = inject(ButtonService);
        this.ButtonTypes = ButtonTypeEnum;
        this.ButtonIcons = ButtonIconEnum;
        this.ButtonIconPositions = ButtonIconPositionEnum;
        this.ButtonFontWeights = ButtonFontWeights;
        this.ButtonModel = new ButtonModel();
    }
    ngAfterViewInit() {
    }
    ngOnInit() {
        this.startListenToShowCommand();
        this.startToListenToButtonClick();
    }
    startListenToShowCommand() {
        this.ModalService.showModal.subscribe((modalModel) => {
            this.configModel = modalModel;
            console.log(this.configModel);
            this.isVisible = true;
        });
    }
    startToListenToButtonClick() {
        this._ButtonService.click.subscribe((btnModel) => {
            if (btnModel.name == this.configModel.BtnCancelName) {
                this.isVisible = false;
            }
            if (btnModel.name == this.configModel.BtnOkName) {
                this.isVisible = false;
            }
            this.ConcluirLoadingButton();
        });
    }
    ConcluirLoadingButton() {
        let btnModel = new ButtonModel();
        btnModel.name = this.configModel.BtnCancelName;
        btnModel.state = false;
        this._ButtonService.loadingState.next(btnModel);
        btnModel.name = this.configModel.BtnOkName;
        this._ButtonService.loadingState.next(btnModel);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ModalComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.0", type: ModalComponent, isStandalone: true, selector: "app-modal", ngImport: i0, template: "<section\r\n[style.display]=\"isVisible ? '':'none'\"\r\n>\r\n    <form\r\n    [style.padding]=\"configModel.BtnsFontSize + 'px ' + configModel.BtnsFontSize*2 + 'px'\"\r\n    [style.border-radius]=\"configModel.BtnsFontSize * 0.8 +'px'\"\r\n    >\r\n        <p\r\n        [style.font-family]=\"'Arial'\"\r\n        [style.font-size]=\"configModel.BtnsFontSize + 'px'\"\r\n        >{{configModel.ModalMessage}}</p>\r\n        <div class=\"btns-container\"\r\n        [style.padding-top]=\"configModel.BtnsFontSize*2 + 'px'\"\r\n        >\r\n        @if(!configModel.OnlyOkButtonEnabled){\r\n            <app-button\r\n            [style.margin-right]=\"configModel.BtnsFontSize*2 + 'px'\"\r\n                [name]=\"configModel.BtnCancelName\"\r\n                [_ButtonType]=\"ButtonTypes.Button\"\r\n                [_BorderRadius]=\"200\"\r\n                [_Width]=\"configModel.BtnCancelWidth\"\r\n                [_Height]=\"configModel.BtnCancelHeight\"\r\n                [BackGroundColorNormal]=\"''\"\r\n                [BackGroundColorHover]=\"''\"\r\n                [_IconEnabled]=\"false\"\r\n                [_Icon]=\"ButtonIcons.AddFile\"\r\n                [IconOrientation]=\"ButtonIconPositions.Top\"\r\n                [_IconDistanceFromText]=\"15\"\r\n                [IconColorNormal]=\"'rgb(231, 230, 230)'\"\r\n                [IconColorHover]=\"'rgb(249, 249, 249)'\"\r\n                [_TextEnabled]=\"true\"\r\n                [_Text]=\"configModel.BtnCancelText\"\r\n                [TextColorNormal]=\"'black'\"\r\n                [TextColorHover]=\"'black'\"\r\n                [_TextFontFamily]=\"'Arial'\"\r\n                [_FontWeight]=\"ButtonFontWeights.Regular\"\r\n                [_FontSize]=\"configModel.BtnsFontSize\"\r\n            />\r\n        }\r\n            <app-button\r\n                [name]=\"configModel.BtnOkName\"\r\n                [_ButtonType]=\"ButtonTypes.Button\"\r\n                [_BorderRadius]=\"200\"\r\n                [_Width]=\"configModel.BtnOkWidth\"\r\n                [_Height]=\"configModel.BtnOkHeight\"\r\n                [BackGroundColorNormal]=\"'#056CF2'\"\r\n                [BackGroundColorHover]=\"'#3281e9'\"\r\n                [_IconEnabled]=\"false\"\r\n                [_Icon]=\"ButtonIcons.AddFile\"\r\n                [IconOrientation]=\"ButtonIconPositions.Top\"\r\n                [_IconDistanceFromText]=\"15\"\r\n                [IconColorNormal]=\"'var(--azulEscuro)'\"\r\n                [IconColorHover]=\"'var(--azulEscuro)'\"\r\n                [_TextEnabled]=\"true\"\r\n                [_Text]=\"configModel.BtnOkText\"\r\n                [TextColorNormal]=\"'white'\"\r\n                [TextColorHover]=\"'white'\"\r\n                [_TextFontFamily]=\"'Arial'\"\r\n                [_FontWeight]=\"ButtonFontWeights.Regular\"\r\n                [_FontSize]=\"configModel.BtnsFontSize\"\r\n            />\r\n        </div>\r\n        \r\n    </form>\r\n</section>\r\n", styles: ["section{position:fixed;z-index:1000;width:100vw;height:100vh;background:transparent;box-shadow:0 4px 30px #0000001a;backdrop-filter:blur(3.6px);-webkit-backdrop-filter:blur(3.6px);display:flex;align-items:start;justify-content:center}section>form{background-color:#fff;display:flex;flex-direction:column;box-shadow:#0000003d 0 3px 8px;width:40%}section>form>.btns-container{display:flex;align-items:center;justify-content:end}@media (max-width: 1024px){section>form{width:60%}}@media (max-width: 500px){section>form{width:70%}}\n"], dependencies: [{ kind: "component", type: ButtonComponent, selector: "app-button", inputs: ["_ButtonType", "_BorderRadius", "_Width", "_Height", "_Icon", "_IconDistanceFromText", "_IconEnabled", "_Text", "_FontSize", "_FontWeight", "_TextFontFamily", "_TextEnabled", "name", "BackGroundColorNormal", "BackGroundColorHover", "IconColorNormal", "IconColorHover", "TextColorNormal", "TextColorHover", "IconOrientation"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.0", ngImport: i0, type: ModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-modal', imports: [ButtonComponent], template: "<section\r\n[style.display]=\"isVisible ? '':'none'\"\r\n>\r\n    <form\r\n    [style.padding]=\"configModel.BtnsFontSize + 'px ' + configModel.BtnsFontSize*2 + 'px'\"\r\n    [style.border-radius]=\"configModel.BtnsFontSize * 0.8 +'px'\"\r\n    >\r\n        <p\r\n        [style.font-family]=\"'Arial'\"\r\n        [style.font-size]=\"configModel.BtnsFontSize + 'px'\"\r\n        >{{configModel.ModalMessage}}</p>\r\n        <div class=\"btns-container\"\r\n        [style.padding-top]=\"configModel.BtnsFontSize*2 + 'px'\"\r\n        >\r\n        @if(!configModel.OnlyOkButtonEnabled){\r\n            <app-button\r\n            [style.margin-right]=\"configModel.BtnsFontSize*2 + 'px'\"\r\n                [name]=\"configModel.BtnCancelName\"\r\n                [_ButtonType]=\"ButtonTypes.Button\"\r\n                [_BorderRadius]=\"200\"\r\n                [_Width]=\"configModel.BtnCancelWidth\"\r\n                [_Height]=\"configModel.BtnCancelHeight\"\r\n                [BackGroundColorNormal]=\"''\"\r\n                [BackGroundColorHover]=\"''\"\r\n                [_IconEnabled]=\"false\"\r\n                [_Icon]=\"ButtonIcons.AddFile\"\r\n                [IconOrientation]=\"ButtonIconPositions.Top\"\r\n                [_IconDistanceFromText]=\"15\"\r\n                [IconColorNormal]=\"'rgb(231, 230, 230)'\"\r\n                [IconColorHover]=\"'rgb(249, 249, 249)'\"\r\n                [_TextEnabled]=\"true\"\r\n                [_Text]=\"configModel.BtnCancelText\"\r\n                [TextColorNormal]=\"'black'\"\r\n                [TextColorHover]=\"'black'\"\r\n                [_TextFontFamily]=\"'Arial'\"\r\n                [_FontWeight]=\"ButtonFontWeights.Regular\"\r\n                [_FontSize]=\"configModel.BtnsFontSize\"\r\n            />\r\n        }\r\n            <app-button\r\n                [name]=\"configModel.BtnOkName\"\r\n                [_ButtonType]=\"ButtonTypes.Button\"\r\n                [_BorderRadius]=\"200\"\r\n                [_Width]=\"configModel.BtnOkWidth\"\r\n                [_Height]=\"configModel.BtnOkHeight\"\r\n                [BackGroundColorNormal]=\"'#056CF2'\"\r\n                [BackGroundColorHover]=\"'#3281e9'\"\r\n                [_IconEnabled]=\"false\"\r\n                [_Icon]=\"ButtonIcons.AddFile\"\r\n                [IconOrientation]=\"ButtonIconPositions.Top\"\r\n                [_IconDistanceFromText]=\"15\"\r\n                [IconColorNormal]=\"'var(--azulEscuro)'\"\r\n                [IconColorHover]=\"'var(--azulEscuro)'\"\r\n                [_TextEnabled]=\"true\"\r\n                [_Text]=\"configModel.BtnOkText\"\r\n                [TextColorNormal]=\"'white'\"\r\n                [TextColorHover]=\"'white'\"\r\n                [_TextFontFamily]=\"'Arial'\"\r\n                [_FontWeight]=\"ButtonFontWeights.Regular\"\r\n                [_FontSize]=\"configModel.BtnsFontSize\"\r\n            />\r\n        </div>\r\n        \r\n    </form>\r\n</section>\r\n", styles: ["section{position:fixed;z-index:1000;width:100vw;height:100vh;background:transparent;box-shadow:0 4px 30px #0000001a;backdrop-filter:blur(3.6px);-webkit-backdrop-filter:blur(3.6px);display:flex;align-items:start;justify-content:center}section>form{background-color:#fff;display:flex;flex-direction:column;box-shadow:#0000003d 0 3px 8px;width:40%}section>form>.btns-container{display:flex;align-items:center;justify-content:end}@media (max-width: 1024px){section>form{width:60%}}@media (max-width: 500px){section>form{width:70%}}\n"] }]
        }] });

var ModalIconsEnum;
(function (ModalIconsEnum) {
    ModalIconsEnum["AddUser"] = "fi fi-sr-user-add";
    ModalIconsEnum["User"] = "fi fi-sr-user";
    ModalIconsEnum["Lock"] = "fi fi-sr-lock";
    ModalIconsEnum["EyeOpen"] = "fi fi-ss-eye";
    ModalIconsEnum["EyeClose"] = "fi fi-ss-eye-crossed";
    ModalIconsEnum["ItemClosed"] = "fi fi-tr-caret-down";
    ModalIconsEnum["ItemOpenned"] = "fi fi-rr-caret-down";
    ModalIconsEnum["Done_Fill"] = "fi fi-sr-octagon-check";
    ModalIconsEnum["Done_OutLine"] = "fi fi-rr-check-circle";
    ModalIconsEnum["Doing_Pending_Outline"] = "fi fi-br-duration-alt";
    ModalIconsEnum["Doing_Pending_Fill"] = "fi fi-ss-duration-alt";
    ModalIconsEnum["NotDone"] = "fi fi-sr-cross-circle";
    ModalIconsEnum["Alert"] = "fi fi-sr-exclamation";
    ModalIconsEnum["Close"] = "fi fi-br-cross";
    ModalIconsEnum["Home"] = "fi fi-sr-home";
    ModalIconsEnum["Key"] = "fi fi-sr-key";
    ModalIconsEnum["Company"] = "fi fi-rs-building";
    ModalIconsEnum["NoteBook"] = "fi fi-br-notebook-alt";
    ModalIconsEnum["AddFile"] = "fi fi-rr-add-document";
    ModalIconsEnum["PageGoBack"] = "fi fi-rr-angle-circle-left";
    ModalIconsEnum["PDFFile"] = "fi fi-sr-file-pdf";
    ModalIconsEnum["DowloadFile"] = "fi fi-sr-file-download";
    ModalIconsEnum["Phone"] = "fi fi-sr-phone-call";
    ModalIconsEnum["Edit"] = "fi fi-sr-pencil";
    ModalIconsEnum["Delete"] = "fi fi-sr-trash";
    ModalIconsEnum["Rotas"] = "fi fi-br-route";
    ModalIconsEnum["Hamburger"] = "fi fi-br-menu-burger";
    ModalIconsEnum["Lubrificacao"] = "fi fi-rr-oil-can";
})(ModalIconsEnum || (ModalIconsEnum = {}));

/*
 * Public API Surface of lightning-tec-br-angular-components
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AlertComponent, AlertIconsEnum, AlertModel, AlertService, AlertTypesEnum, ButtonComponent, ButtonFontWeights, ButtonIconEnum, ButtonIconPositionEnum, ButtonModel, ButtonService, ButtonTypeEnum, FormFielTxtModel, FormFieldComboModel, FormFieldComponent, FormFieldCountryDataFormat, FormFieldFontWeights, FormFieldIconsEnum, FormFieldModel, FormFieldService, FormFieldTxtInputTypesEnum, FormFieldTypes, LabelComponent, LabelFontWeights, LabelIconEnum, LabelIconPositionEnum, LabelModel, LabelService, ListItemComponent, ListItemFontWeights, ListItemIcons, ListItemModel, ListItemPositions, ListItemService, ListItemStateModel, ModalComponent, ModalIconsEnum, ModalModel, ModalService, TableComponent, TableFontWeights, TableModel, TableModes, TableService };
//# sourceMappingURL=lightning-tec-br-angular-components.mjs.map
