import { ElementRef, OnInit } from '@angular/core';
import { ButtonTypeEnum, ButtonIconEnum, ButtonIconPositionEnum, ButtonFontWeights } from './button.enum';
import { ButtonService } from './button.service';
import { ButtonModel } from './button.model';
import { AlertService } from '../alert/alert.service';
import { AlertTypesEnum } from '../alert/alert.enum';
import { AlertModel } from '../alert/alert.model';
import { LabelModel } from '../label/label.model';
import { LabelService } from '../label/label.service';
import { FormFieldService } from '../form-field/form-field.service';
import * as i0 from "@angular/core";
export declare class ButtonComponent implements OnInit {
    private element;
    _BackGroundColor: string;
    _ButtonType: import("@angular/core").InputSignal<ButtonTypeEnum>;
    _BorderRadius: import("@angular/core").InputSignal<number>;
    _Width: import("@angular/core").InputSignal<number>;
    _Height: import("@angular/core").InputSignal<number>;
    ngStyle: object;
    _Icon: import("@angular/core").InputSignal<ButtonIconEnum>;
    _IconFontSize: number;
    _IconOrientation: string;
    _IconMarginType: string;
    _IconDistanceFromTextObject: object;
    _IconColor: string;
    _IconDistanceFromText: import("@angular/core").InputSignal<number>;
    _IconEnabled: import("@angular/core").InputSignal<boolean>;
    _TextColor: string;
    _Text: import("@angular/core").InputSignal<string>;
    _FontSize: import("@angular/core").InputSignal<number>;
    _FontWeight: import("@angular/core").InputSignal<ButtonFontWeights>;
    _TextFontFamily: import("@angular/core").InputSignal<string>;
    _TextEnabled: import("@angular/core").InputSignal<boolean>;
    name: import("@angular/core").InputSignal<string>;
    BackGroundColorNormal: import("@angular/core").InputSignal<string>;
    BackGroundColorHover: import("@angular/core").InputSignal<string>;
    IconColorNormal: import("@angular/core").InputSignal<string>;
    IconColorHover: import("@angular/core").InputSignal<string>;
    TextColorNormal: import("@angular/core").InputSignal<string>;
    TextColorHover: import("@angular/core").InputSignal<string>;
    IconOrientation: import("@angular/core").InputSignal<ButtonIconPositionEnum>;
    _LoadingState: boolean;
    _AlertState: boolean;
    ButtonModel: ButtonModel;
    ButtonService: ButtonService;
    AlertService: AlertService;
    FormFieldService: FormFieldService;
    AlertModel: AlertModel;
    LabelService: LabelService;
    LabelModel: LabelModel;
    readonly AlertTypesEnum: typeof AlertTypesEnum;
    constructor(element: ElementRef);
    ngOnInit(): void;
    OnMouseOver(): void;
    OnMouseOut(): void;
    OnClick(): void;
    startListenToLoadingState(): void;
    startListenToAlertState(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ButtonComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ButtonComponent, "app-button", never, { "_ButtonType": { "alias": "_ButtonType"; "required": true; "isSignal": true; }; "_BorderRadius": { "alias": "_BorderRadius"; "required": true; "isSignal": true; }; "_Width": { "alias": "_Width"; "required": true; "isSignal": true; }; "_Height": { "alias": "_Height"; "required": true; "isSignal": true; }; "_Icon": { "alias": "_Icon"; "required": true; "isSignal": true; }; "_IconDistanceFromText": { "alias": "_IconDistanceFromText"; "required": true; "isSignal": true; }; "_IconEnabled": { "alias": "_IconEnabled"; "required": true; "isSignal": true; }; "_Text": { "alias": "_Text"; "required": true; "isSignal": true; }; "_FontSize": { "alias": "_FontSize"; "required": true; "isSignal": true; }; "_FontWeight": { "alias": "_FontWeight"; "required": true; "isSignal": true; }; "_TextFontFamily": { "alias": "_TextFontFamily"; "required": true; "isSignal": true; }; "_TextEnabled": { "alias": "_TextEnabled"; "required": true; "isSignal": true; }; "name": { "alias": "name"; "required": true; "isSignal": true; }; "BackGroundColorNormal": { "alias": "BackGroundColorNormal"; "required": true; "isSignal": true; }; "BackGroundColorHover": { "alias": "BackGroundColorHover"; "required": true; "isSignal": true; }; "IconColorNormal": { "alias": "IconColorNormal"; "required": true; "isSignal": true; }; "IconColorHover": { "alias": "IconColorHover"; "required": true; "isSignal": true; }; "TextColorNormal": { "alias": "TextColorNormal"; "required": true; "isSignal": true; }; "TextColorHover": { "alias": "TextColorHover"; "required": true; "isSignal": true; }; "IconOrientation": { "alias": "IconOrientation"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
