import { ElementRef, OnInit } from '@angular/core';
import { FormFieldIconsEnum, FormFieldTxtInputTypesEnum, FormFieldFontWeights, FormFieldCountryDataFormat, FormFieldTypes } from './form-field.enum';
import { FormFieldService } from './form-field.service';
import { FormFieldModel, FormFielTxtModel, FormFieldComboModel } from './form-field.model';
import { AlertTypesEnum } from '../alert/alert.enum';
import { AlertService } from '../alert/alert.service';
import { ChangeDetectorRef } from '@angular/core';
import * as i0 from "@angular/core";
export declare class FormFieldComponent implements OnInit {
    private element;
    private cd;
    _Icon: import("@angular/core").InputSignal<FormFieldIconsEnum>;
    Name: import("@angular/core").InputSignal<string>;
    _placeHolderType: string;
    _placeHolderValue: import("@angular/core").InputSignal<string>;
    _PasswordIcon: string;
    _IconColor: import("@angular/core").InputSignal<string>;
    _FontColor: import("@angular/core").InputSignal<string>;
    _FontSize: import("@angular/core").InputSignal<number>;
    _FontFamily: import("@angular/core").InputSignal<string>;
    _FontWeight: import("@angular/core").InputSignal<FormFieldFontWeights>;
    _Options: import("@angular/core").InputSignal<FormFieldComboModel[]>;
    _Width: import("@angular/core").InputSignal<number>;
    _Height: import("@angular/core").InputSignal<number>;
    TxtInputType: import("@angular/core").InputSignal<FormFieldTxtInputTypesEnum>;
    IconEnabled: import("@angular/core").InputSignal<boolean>;
    CountryDataFormat: import("@angular/core").InputSignal<FormFieldCountryDataFormat>;
    text: string;
    _AlertState: boolean;
    FieldType: import("@angular/core").InputSignal<FormFieldTypes>;
    valueFromService: string;
    Mask: string;
    Prefixo: string;
    Sufixo: string;
    NumberMaskSufix: import("@angular/core").InputSignal<string>;
    showMaskTyped: boolean;
    thousandSeparator: string;
    NCasasDecimais: import("@angular/core").InputSignal<number>;
    FormFieldModel: FormFieldModel;
    FormFielTxtModel: FormFielTxtModel;
    FormFieldComboModel: FormFieldComboModel;
    readonly AlertTypesEnum: typeof AlertTypesEnum;
    readonly FormFieldIconsEnum: typeof FormFieldIconsEnum;
    readonly FormFieldTxtInputTypesEnum: typeof FormFieldTxtInputTypesEnum;
    readonly FormFieldDataFormat: typeof FormFieldCountryDataFormat;
    readonly FormFieldTypes: typeof FormFieldTypes;
    FormFieldService: FormFieldService;
    AlertService: AlertService;
    constructor(element: ElementRef, cd: ChangeDetectorRef);
    ngOnInit(): void;
    onTxtChange(): void;
    onComboChange(): void;
    startListenToTextChange(): void;
    startListenToAlertState(): void;
    togglePasswordView(): void;
    configMask(): void;
    getIDFromOption(valueText: string): number;
    enterPressed(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormFieldComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FormFieldComponent, "app-form-field", never, { "_Icon": { "alias": "_Icon"; "required": true; "isSignal": true; }; "Name": { "alias": "Name"; "required": true; "isSignal": true; }; "_placeHolderValue": { "alias": "_placeHolderValue"; "required": true; "isSignal": true; }; "_IconColor": { "alias": "_IconColor"; "required": true; "isSignal": true; }; "_FontColor": { "alias": "_FontColor"; "required": true; "isSignal": true; }; "_FontSize": { "alias": "_FontSize"; "required": true; "isSignal": true; }; "_FontFamily": { "alias": "_FontFamily"; "required": true; "isSignal": true; }; "_FontWeight": { "alias": "_FontWeight"; "required": true; "isSignal": true; }; "_Options": { "alias": "_Options"; "required": true; "isSignal": true; }; "_Width": { "alias": "_Width"; "required": true; "isSignal": true; }; "_Height": { "alias": "_Height"; "required": true; "isSignal": true; }; "TxtInputType": { "alias": "TxtInputType"; "required": true; "isSignal": true; }; "IconEnabled": { "alias": "IconEnabled"; "required": true; "isSignal": true; }; "CountryDataFormat": { "alias": "CountryDataFormat"; "required": true; "isSignal": true; }; "FieldType": { "alias": "FieldType"; "required": true; "isSignal": true; }; "NumberMaskSufix": { "alias": "NumberMaskSufix"; "required": true; "isSignal": true; }; "NCasasDecimais": { "alias": "NCasasDecimais"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
