import { OnInit, OnDestroy, ElementRef, AfterViewInit } from '@angular/core';
import { TableFontWeights, TableModes } from './table.enum';
import { TableService } from './table.service';
import * as i0 from "@angular/core";
export declare class TableComponent implements OnInit, OnDestroy, AfterViewInit {
    tbody: ElementRef;
    nodes: NodeList;
    nodeSelectedIndex: number;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    ngOnInit(): void;
    private destroy;
    name: import("@angular/core").InputSignal<string>;
    TableMode: import("@angular/core").InputSignal<TableModes>;
    _FontFamily: import("@angular/core").InputSignal<string>;
    _FontSize: import("@angular/core").InputSignal<number>;
    _Header_FontColor: import("@angular/core").InputSignal<string>;
    _Header_FontWeight: import("@angular/core").InputSignal<TableFontWeights>;
    _Header_BackGroundColor: import("@angular/core").InputSignal<string>;
    _Body_FontColor: import("@angular/core").InputSignal<string>;
    _Body_FontWeight: import("@angular/core").InputSignal<TableFontWeights>;
    _Body_BackGroundColor01: import("@angular/core").InputSignal<string>;
    _Body_BackGroundColor02: import("@angular/core").InputSignal<string>;
    _Body_BackGroundColorHover: import("@angular/core").InputSignal<string>;
    _BorderVerticalON: import("@angular/core").InputSignal<boolean>;
    _BorderHorizontalON: import("@angular/core").InputSignal<boolean>;
    _BorderColor: import("@angular/core").InputSignal<string>;
    _BorderSize: import("@angular/core").InputSignal<number>;
    _ContainerWidth: import("@angular/core").InputSignal<number>;
    _ContainerHeight: import("@angular/core").InputSignal<number>;
    NomeColunaJSONID: import("@angular/core").InputSignal<string>;
    NomeColunasJSON: import("@angular/core").InputSignal<string[]>;
    NomeColunasDisplay: import("@angular/core").InputSignal<string[]>;
    UnidadesDeMedidaDasColunas: import("@angular/core").InputSignal<string[]>;
    NCasasDecimaisDasColunas: import("@angular/core").InputSignal<number[]>;
    rowsOnDisplay: any[];
    rowsOnMemory: any[];
    headers: string[];
    TableService: TableService;
    rowSelected: boolean;
    readonly TableModes: typeof TableModes;
    startListenToDataChange(): void;
    OnLineSelected(row: object): void;
    OnMouseEnter(row: object): void;
    OnMouseLeave(row: object): void;
    VerificarSeENecessarioDeletarColunasDeUmObjeto(listaObjetos: object[], ListaDeNovosNomes: string[]): boolean;
    MudaNomesDasPropriedadesDeUmObjeto(listaObjetos: object[], ListaDeNovosNomes: string[], ListaDeNomesAntigosParaManter: string[]): object[];
    DeletaPropriedadesDeCadaObjetoDeUmaLista(listaObjetos: object[], ListaColunasParaManter: string[]): object[];
    ListaNomesColunasDeletadas(objOriginal: object, ListaColunasParaManter: string[]): string[];
    ListaDeObjetosComUnidadesDeMedidas(listaObjetos: object[], listaUnidadesMedida: string[]): object[];
    ListaDeObjetosComCamposNumericosArredondados(listaObjetos: any[], listadeArredondamentos: number[]): object[];
    static ɵfac: i0.ɵɵFactoryDeclaration<TableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableComponent, "app-table", never, { "name": { "alias": "name"; "required": true; "isSignal": true; }; "TableMode": { "alias": "TableMode"; "required": true; "isSignal": true; }; "_FontFamily": { "alias": "_FontFamily"; "required": true; "isSignal": true; }; "_FontSize": { "alias": "_FontSize"; "required": true; "isSignal": true; }; "_Header_FontColor": { "alias": "_Header_FontColor"; "required": true; "isSignal": true; }; "_Header_FontWeight": { "alias": "_Header_FontWeight"; "required": true; "isSignal": true; }; "_Header_BackGroundColor": { "alias": "_Header_BackGroundColor"; "required": true; "isSignal": true; }; "_Body_FontColor": { "alias": "_Body_FontColor"; "required": true; "isSignal": true; }; "_Body_FontWeight": { "alias": "_Body_FontWeight"; "required": true; "isSignal": true; }; "_Body_BackGroundColor01": { "alias": "_Body_BackGroundColor01"; "required": true; "isSignal": true; }; "_Body_BackGroundColor02": { "alias": "_Body_BackGroundColor02"; "required": true; "isSignal": true; }; "_Body_BackGroundColorHover": { "alias": "_Body_BackGroundColorHover"; "required": true; "isSignal": true; }; "_BorderVerticalON": { "alias": "_BorderVerticalON"; "required": true; "isSignal": true; }; "_BorderHorizontalON": { "alias": "_BorderHorizontalON"; "required": true; "isSignal": true; }; "_BorderColor": { "alias": "_BorderColor"; "required": true; "isSignal": true; }; "_BorderSize": { "alias": "_BorderSize"; "required": true; "isSignal": true; }; "_ContainerWidth": { "alias": "_ContainerWidth"; "required": true; "isSignal": true; }; "_ContainerHeight": { "alias": "_ContainerHeight"; "required": true; "isSignal": true; }; "NomeColunaJSONID": { "alias": "NomeColunaJSONID"; "required": true; "isSignal": true; }; "NomeColunasJSON": { "alias": "NomeColunasJSON"; "required": true; "isSignal": true; }; "NomeColunasDisplay": { "alias": "NomeColunasDisplay"; "required": true; "isSignal": true; }; "UnidadesDeMedidaDasColunas": { "alias": "UnidadesDeMedidaDasColunas"; "required": true; "isSignal": true; }; "NCasasDecimaisDasColunas": { "alias": "NCasasDecimaisDasColunas"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
